DECLARE SUB TIDE5 (IPRINT%, ITY#, ITM#, ITD#, HR#, MN#, SC#, GT#)
DECLARE SUB ETPOTW (IPRINT%, IMODEL%, DLAT#, DLON#, DH#, DGRAV#, DAZ#, IC%, ITY#, ITM#, ITD#, DTH#, MAXNW%, DTHAM#(), DTHPH#(), DTHFR#(), NW%)
DECLARE SUB GEOEXT (DEXTIM#)
DECLARE SUB ATAN2 (Y#, X#, A#)
DECLARE SUB ETGCOF (IPRINT%, DLAT#, DLON#, DH#, DGRAV#, DAZ#, IC%, DGK#(), DPK#())
'***********************************************************************
'*                                                                     *
'*    Program ETGTAB.BAS, Version 940208 MS-QuickBasic 4.0.            *
'*                                                                     *
'***********************************************************************
DECLARE SUB ETASTE (IPRINT%, IMODEL%, DLON#, ITY#, ITM#, ITD#, DTH#, DAS#(), DASP#())
DECLARE SUB ETGREG (ITY#, ITM#, ITD#, DTH#)
DECLARE SUB ETJULD (ITY#, ITM#, ITD#, DTH#, DJULD#)
DECLARE SUB ETMUTC (IPRINT%, DTUJD#, DDT#)
      DIM DAS#(8), DASP#(8)
      DIM DGK#(12), DPK#(12)
      OPEN "TAPE6" FOR OUTPUT AS #6
      IPRINT% = 2
      CALL GEOEXT(DEXTIM#)
      ITY# = 1988#
      ITM# = 1#
      ITD# = 1#
      HR# = 0#
      MN# = 0#
      SC# = 0#
      IPRINT% = 0
      T1# = TIMER
      DT# = 0#
      DDT# = 1#
      FOR J% = 1 TO 8760
      CALL TIDE5(IPRINT%, ITY#, ITM#, ITD#, HR#, MN#, SC#, GT#)
REM Runden auf 0.001 nm/s**2:
      GT# = INT(GT# * 1000#) / 1000#
      PRINT ITY#; ITM#; ITD#; HR#; GT#
      PRINT #6, ITY#; ITM#; ITD#; HR#; GT#
      HR# = HR# + DDT#
      CALL ETGREG(ITY#, ITM#, ITD#, HR#)
      NEXT J%
      CALL GEOEXT(DEXTIM#)
END

      SUB ATAN2 (Y#, X#, A#)
      PI# = 3.141592653589793#
'     A# returns angle in rad
      IF X# = 0 THEN
         A# = PI# / 2#
         GOTO retat
      END IF
      IF X# < 0 THEN
        IF Y# >= 0 THEN
         A# = ATN(Y# / X#) + PI#
         GOTO retat
        END IF
        IF Y# < 0 THEN
         A# = ATN(Y# / X#) - PI#
         GOTO retat
        END IF
      END IF
      A# = ATN(Y# / X#)
retat: '
      END SUB

      SUB ETASTE (IPRINT%, IMODEL%, DLON#, ITY#, ITM#, ITD#, DTH#, DAS#(), DASP#()) STATIC
'***********************************************************************
'*                                                                     *
'*    ROUTINE ETASTE, VERSION 930528 MS-QuickBasic.                    *
'*                                                                     *
'*    THE ROUTINE ETASTE COMPUTES THE ASTRONOMICAL ELEMENTS FOR        *
'*    A SPECIFIC EPOCH.                                                *
'*                                                                     *
'*    REFERENCE...WENZEL, H.-G. 1976...ZUR GENAUIGKEIT VON GRAVIME-    *
'*                TRISCHEN ERDEGEZEITENBEOBACHTUNGEN. WISSENSCHAFT-    *
'*                LICHE ARBEITEN DER LEHRSTUEHLE FUER GEODAESIE,       *
'*                PHOTOGRAMMETRIE UND KARTOGRAPHIE AN DER TECHNI-      *
'*                SCHEN UNIVERSITAET HANNOVER NR. 67, HANNOVER 1976.   *
'*                                                                     *
'*    ALL VARIABLES WITH D AS FIRST CHARACTER ARE DOUBLE PRECISION.    *
'*                                                                     *
'*    INPUT PARAMETER DESCRIPTION...                                   *
'*    ==============================                                   *
'*                                                                     *
'*    IPRINT...    PRINTOUT PARAMETER. FOR IPRINT=0, NOTHING WILL      *
'*                 BE PRINTED ON UNITS IUN6 AND IUN7.                  *
'*    IMODEL...    PARAMETER FOR THE USED TIDAL POTENTIAL MODEL.       *
'*    DLON...      ELLIPSOIDAL LONGITUDE OF THE STATION IN DEGREE      *
'*                 POSITIVE EAST OF GREENWHICH.                        *
'*    ITY...       INTEGER YEAR  OF THE EPOCH (E.G. 1988).             *
'*    ITM...       INTEGER MONTH OF THE EPOCH (E.G. JANUARY = 1).      *
'*    ITD...       INTEGER DAY   OF THE EPOCH.                         *
'*    DTH...       HOUR          OF THE EPOCH IN UTC.                  *
'*                                                                     *
'*    OUTPUT PARAMETER DESCRIPTION...                                  *
'*    ===============================                                  *
'*                                                                     *
'*    DAS(1)...    MEAN MOONTIME IN DEGREE.                            C
'*    DAS(2)...    MEAN LONGITUDE OF THE MOON IN DEGREE.               C
'*    DAS(3)...    MEAN LONGITUDE OF THE SUN  IN DEGREE.               C
'*    DAS(4)...    MEAN LONGITUDE OF THE PERIGEE OF THE MONN'S ORBIT   C
'*                 IN DEGREE.                                          C
'*    DAS(5)...    NEGATIVE MEAN LONGITUDE OF THE ASCENDING NODE OF    C
'*                 THE MOON'S ORBIT IN DEGREE.                         C
'*    DAS(6)...    MEAN LONGITUDE OF THE PERIGEE OF THE SUN'S ORBIT    C
'*                 IN DEGREE.                                          C
'*    DAS(7)...    PERIOD OF JUPITER'S OPPOSITION IN DEGREE (FOR       C
'*                 TAMURA 1987 TIDAL POTENTIAL DEVELOPMENT).           C
'*    DAS(8)...    PERIOD OF VENUS'S CONJUNCTION IN DEGREE (FOR        C
'*                 TAMURA 1987 TIDAL POTENTIAL DEVELOPMENT).           C
'*    DASP(1...8): TIME DERIVATIVES OF THE CORRESPONDING VARIABLES     C
'*                 DAS IN DEGREE PER HOUR.                             C
'*                                                                     C
'*    USED ROUTINES...                                                 C
'*    ================                                                 C
'*                                                                     C
'*    SUBROUTINE ETJULD : JULIAN DATE.                                 C
'*    SUBROUTINE ETMUTC : DIFFERENCE TDT - UTC.                        C
'*                                                                     C
'*    NUMERICAL ACUURACY...                                            C
'*    =====================                                            C
'*                                                                     C
'*    THE ROUTINE HAS BEEN TESTED ON CDC CYBER 990 OF RRZN HANNOVER    C
'*    WITH 15 DIGITS IN SINGLE PRECISION.                              C
'*                                                                     C
'*    EXECUTION TIME...                                                C
'*    =================                                                C
'*                                                                     C
'*    THE EXECUTION TIME IS ABOUT 0.052 SEC CPU TIME FOR 1000 CALLS    C
'*    OF ROUTINE ETASTE ON CDC CYBER 990 OF RZN HANNOVER USING         C
'*    OPTIMIZATION LEVEL OL=HIGH.                                      C
'*                                                                     C
'*    ROUTINE CREATION...    880130 BY H.-G.WENZEL,                    C
'*                           GEODAETISCHES INSTITUT,                   C
'*                           UNIVERSITAET KARLSRUHE,                   C
'*                           ENGLERSTR. 7,                             C
'*                           D-7500 KARLSRUHE 1,                       C
'*                           FEDERAL REPUBLIC OF GERMANY.              C
'*    ROUTINE MODIFICATION...930528 BY H.-G.WENZEL.                    C
'**********************************************************************C
      IF IPRINT% > 0 THEN
         PRINT " ROUTINE ETASTE, VERSION 930528."
         PRINT " ASTRONOMIC ELEMENTS FOR INITIAL EPOCH:"; ITY#; ITM#; ITD#; DTH#
         PRINT #6, " ROUTINE ETASTE, VERSION 930528."
         PRINT #6, " ASTRONOMIC ELEMENTS FOR INITIAL EPOCH:"; ITY#; ITM#; ITD#; DTH#
      END IF
'***********************************************************************
'*    COMPUTE JULIAN DATE FOR EPOCH ITY#, ITM#, ITD#, DTH#.            *
'***********************************************************************
      CALL ETJULD(ITY#, ITM#, ITD#, DTH#, DTUJD#)
'***********************************************************************
'*    COMPUTE UNIVERSAL TIME EPOCH DTUT IN JULIAN CENTURIES REFERRING  *
'*    TO 1. JANUARY 1900.                                              *
'***********************************************************************
      DTUT# = (DTUJD# - 2415020#) / 36525#
'***********************************************************************
'*    COMPUTE UNIVERSAL TIME EPOCH DTUT20 IN JULIAN CENTURIES          *
'*    REFERRING TO 1. JANUARY 2000 12 H UNIVERSAL TIME.                *
'***********************************************************************
      DTUT20# = (DTUJD# - 2451545#) / 36525#
'***********************************************************************
'*    COMPUTATION OF EPHEMERIS TIME.                                   *
'***********************************************************************
      CALL ETMUTC(IPRINT%, DTUJD#, DDT#)
      PRINT #6, " TDT - UTC ="; DDT#; " s"
      PRINT " TDT - UTC ="; DDT#; " s"
      DT# = DTUT# + DDT# / 3155760000#
      DTDT20# = DTUT20# + DDT# / 3155760000#
'***********************************************************************
'*    COMPUTATION OF ASTRONOMICAL ELEMENTS FOR INITIAL EPOCH FROM      *
'*    NEWCOMBS FORMULA FOR THE SUN AND FROM BROWNS FORMULAS FOR THE    *
'*    MOON (SEE ASTRONOMICAL EPHEMERIS, EXPLANATORY SUPPLEMENT).       *
'***********************************************************************
      DT2# = DT ^ 2
      DT3# = DT ^ 3
      IF IMODEL% = 2 GOTO ast100
      DAS#(2) = 270.434164# + 481267.8831417# * DT# - .0011333# * DT2#
      DAS#(2) = DAS#(2) + .0000019# * DT3#
      DAS#(3) = 279.696678# + 36000.768925# * DT# + .0003025# * DT2#
      DAS#(4) = 334.329556# + 4069.0340333# * DT# - .010325# * DT2#
      DAS#(4) = DAS#(4) - .0000125# * DT3#
      DAS#(5) = 100.816725# + 1934.1420083# * DT# - .0020778# * DT2#
      DAS#(5) = DAS#(5) - .0000022# * DT3#
      DAS#(6) = 281.220833# + 1.719175# * DT# + .0004528# * DT2#
      DAS#(6) = DAS#(6) + .0000033# * DT3#
'***********************************************************************
'*    COMPUTE JUPITER'S AND VENUS'S ARGUMENTS FROM TAMURA'S 1987       *
'*    FORMULAS.                                                        *
'***********************************************************************
      DAS#(7) = 248.1# + 32964.47# * DTDT20#
      DAS#(8) = 81.5# + 22518.44# * DTDT20#
      DASP#(2) = .54901652195037# - .00000000258575# * DT#
      DASP#(2) = DASP#(2) + .00000000000646# * DT2#
      DASP#(3) = .04106863897444# + .0000000006902# * DT#
      DASP#(4) = .0046418366796# - .00000002355692# * DT#
      DASP#(4) = DASP#(4) - .00000000004278# * DT2#
      DASP#(5) = .00220641342494# - .00000000474054# * DT#
      DASP#(5) = DASP#(5) - .0000000000076# * DT2#
      DASP#(6) = .00000196118526# + .00000000103303# * DT#
      DASP#(6) = DASP#(6) + .00000000001141# * DT2#
'***********************************************************************
'*    COMPUTE JUPITER'S AND VENUS'S SPEED FROM TAMURA'S 1987           *
'*    FORMULAS.                                                        *
'***********************************************************************
      DASP#(7) = 32964.47# / (24# * 36525#)
      DASP#(8) = 22518.44# / (24# * 36525#)
      DASP#(1) = DASP#(3) - DASP#(2) + 15#
      FOR I% = 2 TO 8
      D# = INT(DAS#(I%) / 360#)
      DAS#(I%) = DAS#(I%) - D# * 360#
      IF DAS#(I%) < 0# THEN DAS#(I%) = DAS#(I%) + 360#
      NEXT I%
      DAS#(1) = DAS#(3) - DAS#(2) + DLON# + DTH# * 15#
      IF DAS#(1) < 0# THEN DAS#(1) = DAS#(1) + 360#
      GOTO ast200
ast100: '
'***********************************************************************
'*    COMPUTE ASTRONOMICAL ELEMENTS FROM TAMURA 1987 FORMULAS.         *
'***********************************************************************
      DPI# = 4# * ATN(1#)
      DRAD# = DPI# / 180#
      DT2# = DTUT20# ^ 2
      DT3# = DTUT20# ^ 3
      DAL# = 280.4606184# + 36000.7700536# * DTUT20# + .00038793# * DT2#
      DAL# = DAL# - .0000000258# * DT3#
      DALP# = 36000.7700536# + 2# * .00038793# * DTUT20#
      DALP# = DALP# - 3# * .0000000258# * DT2#
      DALP# = DALP# / (24# * 36525#)
      DT2# = DTDT20# ^ 2
      DS# = 218.316656# + 481267.881342# * DTDT20# - .00133# * DT2#
      DSP# = (481267.881342# - 2# * .00133# * DTDT20#) / (24# * 36525#)
      DH# = 280.466449# + 36000.769822# * DTDT20# + .0003036# * DT2#
      DHP# = (36000.769822# + 2# * .0003036# * DTDT20#) / (24# * 36525#)
      DDS# = .004# * COS((29# + 133# * DTDT20#) * DRAD#)
      DDSP# = (-.004# * 133# * DRAD# * SIN((29# + 133# * DTDT20#) * DRAD))
      DDSP# = DDSP# / (24# * 36525#)
      DDH# = .0018# * COS((159# + 19# * DTDT20#) * DRAD#)
      DDHP = (-.0018# * 19# * DRAD# * SIN((159# + 19# * DTDT20#) * DRAD#))
      DDHP# = DDHP# / (24# * 36525#)
      DAS#(1) = DAL# - DS# + DLON# + DTH# * 15#
      DAS#(2) = DS# + DDS#
      DAS#(3) = DH# + DDH#
      DAS#(4) = 83.35324300000001# + 4069.013711# * DTDT20# - .010324# * DT2#
      DAS#(5) = 234.955444# + 1934.136185# * DTDT20# - .002076# * DT2#
      DAS#(6) = 282.937348# + 1.719533# * DTDT20# + .0004597# * DT2#
      DAS#(7) = 248.1# + 32964.47# * DTDT20#
      DAS#(8) = 81.5# + 22518.44# * DTDT20#
'***********************************************************************
'*    COMPUTE THE SPEEDS IN DEGREE PER HOUR.                           *
'***********************************************************************
      DASP#(1) = DALP# - DSP# + 15#
      DASP#(2) = DSP# + DDSP#
      DASP#(3) = DHP# + DDHP#
      DASP#(4) = (4069.013711# - 2# * .010324# * DTDT20#) / (24# * 36525#)
      DASP#(5) = (1934.136185# - 2# * .002076# * DTDT20#) / (24# * 36525#)
      DASP#(6) = (1.719533# + 2# * .0004597# * DTDT20#) / (24# * 36525#)
      DASP#(7) = 32964.47# / (24# * 36525#)
      DASP#(8) = 22518.44# / (24# * 36525#)
      FOR I% = 1 TO 8
      D# = INT(DAS#(I%) / 360#)
      DAS#(I%) = DAS#(I%) - D# * 360#
      IF DAS#(I%) < 0# THEN DAS#(I%) = DAS#(I%) + 360#
      NEXT I%
ast200: IF IPRINT% = 0 THEN GOTO astret
'***********************************************************************
'*    PRINT ASTRONOMICAL ELEMENTS.                                     *
'***********************************************************************
      IF IMODEL% <> 2 THEN
         PRINT " BROWNS FORMULAS FOR THE MOON, NEWCOMBS FORMULAS FOR THE SUN"
         PRINT " TAMURAS FORMULAS FOR JUPITER AND VENUS."
         PRINT " TAU"; DAS#(1); " DEG  TAU."; DASP#(1); " DEG/HOUR"
         PRINT " S  "; DAS#(2); " DEG  S.  "; DASP#(2); " DEG/HOUR"
         PRINT " H  "; DAS#(3); " DEG  H.  "; DASP#(3); " DEG/HOUR"
         PRINT " P  "; DAS#(4); " DEG  P.  "; DASP#(4); " DEG/HOUR"
         PRINT " N  "; DAS#(5); " DEG  N.  "; DASP#(5); " DEG/HOUR"
         PRINT " P1 "; DAS#(6); " DEG  P1. "; DASP#(6); " DEG/HOUR"
         PRINT " JU "; DAS#(7); " DEG  JU. "; DASP#(7); " DEG/HOUR"
         PRINT " VE "; DAS#(8); " DEG  VE. "; DASP#(8); " DEG/HOUR"
        '
         PRINT #6, " BROWNS FORMULAS FOR THE MOON, NEWCOMBS FORMULAS FOR THE SUN"
         PRINT #6, " TAMURAS FORMULAS FOR JUPITER AND VENUS."
         PRINT #6, " TAU"; DAS#(1); " DEG  TAU."; DASP#(1); " DEG/HOUR"
         PRINT #6, " S  "; DAS#(2); " DEG  S.  "; DASP#(2); " DEG/HOUR"
         PRINT #6, " H  "; DAS#(3); " DEG  H.  "; DASP#(3); " DEG/HOUR"
         PRINT #6, " P  "; DAS#(4); " DEG  P.  "; DASP#(4); " DEG/HOUR"
         PRINT #6, " N  "; DAS#(5); " DEG  N.  "; DASP#(5); " DEG/HOUR"
         PRINT #6, " P1 "; DAS#(6); " DEG  P1. "; DASP#(6); " DEG/HOUR"
         PRINT #6, " JU "; DAS#(7); " DEG  JU. "; DASP#(7); " DEG/HOUR"
         PRINT #6, " VE "; DAS#(8); " DEG  VE. "; DASP#(8); " DEG/HOUR"
      ELSE
         PRINT " TAMURAS 1987 FORMULAS ARE USED."
         PRINT " F1 "; DAS#(1); " DEG  F1. "; DASP#(1); " DEG/HOUR"
         PRINT " F2 "; DAS#(2); " DEG  F2. "; DASP#(2); " DEG/HOUR"
         PRINT " F3 "; DAS#(3); " DEG  F3. "; DASP#(3); " DEG/HOUR"
         PRINT " F4  "; DAS#(4); " DEG  F4. "; DASP#(4); " DEG/HOUR"
         PRINT " F5  "; DAS#(5); " DEG  F5. "; DASP#(5); " DEG/HOUR"
         PRINT " F6 "; DAS#(6); " DEG  F6. "; DASP#(6); " DEG/HOUR"
         PRINT " F7 "; DAS#(7); " DEG  F7. "; DASP#(7); " DEG/HOUR"
         PRINT " F8 "; DAS#(8); " DEG  F8. "; DASP#(8); " DEG/HOUR"
       '
         PRINT #6, " TAMURAS 1987 FORMULAS ARE USED."
         PRINT #6, " F1 "; DAS#(1); " DEG  F1. "; DASP#(1); " DEG/HOUR"
         PRINT #6, " F2 "; DAS#(2); " DEG  F2. "; DASP#(2); " DEG/HOUR"
         PRINT #6, " F3 "; DAS#(3); " DEG  F3. "; DASP#(3); " DEG/HOUR"
         PRINT #6, " F4 "; DAS#(4); " DEG  F4. "; DASP#(4); " DEG/HOUR"
         PRINT #6, " F5 "; DAS#(5); " DEG  F5. "; DASP#(5); " DEG/HOUR"
         PRINT #6, " F6 "; DAS#(6); " DEG  F6. "; DASP#(6); " DEG/HOUR"
         PRINT #6, " F7 "; DAS#(7); " DEG  F7. "; DASP#(7); " DEG/HOUR"
         PRINT #6, " F8 "; DAS#(8); " DEG  F8. "; DASP#(8); " DEG/HOUR"
      END IF
      PRINT " ***** ROUTINE ETASTE FINISHED EXECUTION."
      PRINT #6, " ***** ROUTINE ETASTE FINISHED EXECUTION."
astret: END SUB

      SUB ETGCOF (IPRINT%, DLAT#, DLON#, DH#, DGRAV#, DAZ#, IC%, DGK#(), DPK#()) STATIC
'***********************************************************************
'*                                                                     *
'*    ROUTINE ETGCOF, VERSION 930608 MS-QuickBasic 4.0.                *
'*                                                                     *
'*    THE ROUTINE ETGCOF COMPUTES THE GEODETIC COEFFICIENTS FOR        *
'*    THE TIDAL POTENTIAL DEVELOPMENT.                                 *
'*                                                                     *
'*    ALL VARIABLES WITH D AS FIRST CHARACTER ARE DOUBLE PRECISION.    *
'*                                                                     *
'*    INPUT PARAMETER DESCRIPTION...                                   *
'*    ==============================                                   *
'*                                                                     *
'*    IPRINT%...   Print parameter. For IPRINT%=0, nothing will be     *
'*                 printed.                                            *
'*    DLAT#...     ELLIPSOIDAL LATITUDE  IN DEGREE.                    *
'*    DLON#...     ELLIPSOIDAL LONGITUDE IN DEGREE, POSITIV EAST       *
'*                 OF GREENWHICH.                                      *
'*    DH#...       ELLIPSOIDAL HEIGHT IN METER.                        *
'*    DGRAV#...    GRAVITY IN M*SEC**-2. IF DGRAV .LT. 9.50,           *
'*                 NORMAL GRAVITY WILL BE COMPUTED FOR THE STATION.    *
'*    DAZ#...      AZIMUT IN DEGREE FROM NORTH DIRECTION CLOCKWISE     *
'*                 (ONLY VALID FOR TIDAL TILT).                        *
'*    IC%...       EARTH TIDE COMPONENT TO BE COMPUTED.                *
'*                 IC%=-1...TIDAL POTENTIAL, GEODETIC COEFFICIENTS     *
'*                          IN M**2/S**2.                              *
'*                 IC%= 0...VERTICAL COMPONENT (GRAVITY VARIATION),    *
'*                          GEODETIC COEFFICIENTS IN NM/SEC**2.        *
'*                 IC%= 1...HORIZONTAL COMPONENT (TIDAL TILT) IN       *
'*                          AZIMUTH DAZ, GEODETIC CEOFFICIENTS IN      *
'*                          MSECA = ARC SEC/1000.                      *
'*                 IC%= 2...SAME AS IC = 1.                            *
'*                 IC%= 3...VOLUME VARIATION, GEODETIC COEFFICIENTS    *
'*                          IN 10**-9.                                 *
'*                 IC%= 4...TIDAL STRAIN (NOT IMPLEMENTED).            *
'*                 IC%= 5...OCEAN TIDES, GEODETIC COEFFICIENTS IN      *
'*                          MILLIMETER.                                *
'*                                                                     *
'*    OUTPUT PARAMETER DESCRIPTION...                                  *
'*    ===============================                                  *
'*                                                                     *
'*    DGK#...      ARRAY (1...12) OF GEODETIC COEFFICIENTS.            *
'*    DGK#(1)...   GEODETIC COEFFICIENT FOR DEGREE 2 AND ORDER 0.      *
'*    DGK#(2)...   GEODETIC COEFFICIENT FOR DEGREE 2 AND ORDER 1.      *
'*    DGK#(3)...   GEODETIC COEFFICIENT FOR DEGREE 2 AND ORDER 2.      *
'*    DGK#(4)...   GEODETIC COEFFICIENT FOR DEGREE 3 AND ORDER 0.      *
'*    DGK#(5)...   GEODETIC COEFFICIENT FOR DEGREE 3 AND ORDER 1.      *
'*    DGK#(6)...   GEODETIC COEFFICIENT FOR DEGREE 3 AND ORDER 2.      *
'*    DGK#(7)...   GEODETIC COEFFICIENT FOR DEGREE 3 AND ORDER 3.      *
'*    DGK#(8)...   GEODETIC COEFFICIENT FOR DEGREE 4 AND ORDER 0.      *
'*    DGK#(9)...   GEODETIC COEFFICIENT FOR DEGREE 4 AND ORDER 1.      *
'*    DGK#(10)...  GEODETIC COEFFICIENT FOR DEGREE 4 AND ORDER 2.      *
'*    DGK#(11)...  GEODETIC COEFFICIENT FOR DEGREE 4 AND ORDER 3.      *
'*    DGK#(12)...  GEODETIC COEFFICIENT FOR DEGREE 4 AND ORDER 4.      *
'*                                                                     *
'*    DPK#...      ARRAY (1...12) OF PHASES IN DEGREE.                 *
'*    DPK#(1)...   PHASE IN DEGREE FOR      DEGREE 2 AND ORDER 0.      *
'*    DPK#(2)...   PHASE IN DEGREE FOR      DEGREE 2 AND ORDER 1.      *
'*    DPK#(3)...   PHASE IN DEGREE FOR      DEGREE 2 AND ORDER 2.      *
'*    DPK#(4)...   PHASE IN DEGREE FOR      DEGREE 3 AND ORDER 0.      *
'*    DPK#(5)...   PHASE IN DEGREE FOR      DEGREE 3 AND ORDER 1.      *
'*    DPK#(6)...   PHASE IN DEGREE FOR      DEGREE 3 AND ORDER 2.      *
'*    DPK#(7)...   PHASE IN DEGREE FOR      DEGREE 3 AND ORDER 3.      *
'*    DPK#(8)...   PHASE IN DEGREE FOR      DEGREE 4 AND ORDER 0.      *
'*    DPK#(9)...   PHASE IN DEGREE FOR      DEGREE 4 AND ORDER 1.      *
'*    DPK#(10)..   PHASE IN DEGREE FOR      DEGREE 4 AND ORDER 2.      *
'*    DPK#(11)..   PHASE IN DEGREE FOR      DEGREE 4 AND ORDER 3.      *
'*    DPK#(12)..   PHASE IN DEGREE FOR      DEGREE 4 AND ORDER 4.      *
'*                                                                     *
'*    USED ROUTINES... NONE.                                           *
'*    ================                                                 *
'*                                                                     *
'*    NUMERICAL ACCURACY...                                            *
'*    =====================                                            *
'*                                                                     *
'*    THE ROUTINE HAS BEEN TESTED ON CDC CYBER 990 OF RRZN HANNOVER    *
'*    WITH 30 DIGITS IN DOUBLE PRECISION. IT SHOULD ALSO RUN WITHOUT   *
'*    NUMERICAL PROBLEMS ON COMPUTERS WITH LOWER WORD LENGTH.          *
'*                                                                     *
'*    EXECUTION TIME...                                                *
'*    =================                                                *
'*                                                                     *
'*    THE EXECUTION TIME IS 0.018 SEC CPU TIME ON CDC CYBER 990 OF     *
'*    RRZN HANNOVER USING OL=HIGH.                                     *
'*                                                                     *
'*    ROUTINE CREATION...    880129 BY H.-G.WENZEL,                    *
'*                           GEODAETISCHES INSTITUT,                   *
'*                           UNIVERSITAET KARLSRUHE,                   *
'*                           ENGLERSTR. 7,                             *
'*                           D-7500 KARLSRUHE 1,                       *
'*                           FEDERAL REPUBLIC OF GERMANY.              *
'*                           TELEPHONE... 0721-6082301.                *
'*    ROUTINE MODIFICATION...900121 BY H.-G.WENZEL.                    *
'***********************************************************************
      DIM CUNIT$(7)
REM   DIM DGK#(12), DPK#(12)
      DIM DGX#(12), DGY#(12), DGZ#(12), DGXS#(12), DGYS#(12), DGZS#(12)
      CUNIT$(1) = "(M/S)**2"
      CUNIT$(2) = "NM/S**2"
      CUNIT$(3) = " MSECA  "
      CUNIT$(4) = " MSECA  "
      CUNIT$(5) = "10**-9  "
      CUNIT$(6) = "10**-9  "
      CUNIT$(7) = "MM      "
      DPI# = 4# * ATN(1#)
      DRAD# = DPI# / 180#
      DRO# = 180# / DPI#
'***********************************************************************
'*    DEFINITION OF ELLIPSOIDAL PARAMETERS OF GEODETIC REFERENCE       *
'*    SYSTEM 1980.                                                     *
'*    DEA  IS MAJOR SEMI AXIS IN METER.                                *
'*    DEE  IS SQUARE OF FIRST ECCENTRICITY (DIMENSIONLESS).            *
'*    DEGM IS GEOCENTRIC GRAVITATION CONSTANT IN METER**3/SEC**2.      *
'***********************************************************************
      DEA# = 6378137#
      DEE# = .0066943800229#
      DEGM1# = 398600.5#
      DEGM# = DEGM1# * 1000000000#
      IF IPRINT% > 0 THEN
         PRINT " ROUTINE ETGCOF, VERSION 930608."
         PRINT " COMPUTATION OF GEODETIC COEFFICIENTS FOR TIDAL POTENTIAL"
         PRINT "  "
         PRINT " ELLIPSOID PARAMETERS GEODETIC REFERENCE SYSTEM 1980"
         PRINT " MAJOR SEMI AXIS                 "; DEA#; "  M"
         PRINT " 1.EXCENTRICITY                  "; DEE#
         PRINT " GEOCENTRIC GRAVITATION  CONSTANT"; DEGM1#; " 10**9 M**3/SEC**2"
         PRINT "  "
       '
         PRINT #6, " ROUTINE ETGCOF, VERSION 930608."
         PRINT #6, " COMPUTATION OF GEODETIC COEFFICIENTS FOR TIDAL POTENTIAL"
         PRINT #6, "  "
         PRINT #6, " ELLIPSOID PARAMETERS GEODETIC REFERENCE SYSTEM 1980"
         PRINT #6, " MAJOR SEMI AXIS                 "; DEA#; "  M"
         PRINT #6, " 1.EXCENTRICITY                  "; DEE#
         PRINT #6, " GEOCENTRIC GRAVITATION  CONSTANT"; DEGM1#; " 10**9 M**3/SEC**2"
         PRINT #6, "  "
      END IF
'***********************************************************************
'*    DCLAT IS COS AND DSLAT IS SIN OF ELLIPSOIDAL LATITUDE.           *
'***********************************************************************
      DCLAT# = COS(DLAT# * DRAD#)
      DSLAT# = SIN(DLAT# * DRAD#)
'***********************************************************************
'*    COMPUTATION OF NORMAL GRAVITY IN M/SEC**2.                       *
'***********************************************************************
      IF DGRAV# < 9.5# THEN
         DGRAV# = 9.78032677# * (1# + .001931851353# * DSLAT# ^ 2)
         DGRAV# = DGRAV# / SQR(1# - DEE# * DSLAT# ^ 2)
         DGRAV# = DGRAV# - .000003086# * DH#
      END IF
'***********************************************************************
'*    COMPUTE ELLIPSOIDAL CURVATURE RADIUS  DN IN METER.               *
'***********************************************************************
      DN# = DEA# / SQR(1# - DEE# * DSLAT# ^ 2)
'***********************************************************************
'*    COMPUTATION OF GEOCENTRIC LATITUDE DPSI IN DEGREE.               *
'***********************************************************************
      DPSI# = DRO# * ATN(((DN# * (1# - DEE#) + DH#) * DSLAT#) / ((DN# + DH#) * DCLAT#))
'***********************************************************************
'*    COMPUTATION OF GEOCENTRIC RADIUS DR1 IN METER.                   *
'***********************************************************************
      DR1# = SQR((DN# + DH#) ^ 2 * DCLAT# ^ 2 + (DN# * (1# - DEE#) + DH#) ^ 2 * DSLAT# ^ 2)
      IF IPRINT% > 0 THEN
        PRINT " STATION PARAMETERS"
        PRINT " LATITUDE                       "; DLAT#; " DEG"
        PRINT " GEOCENTRIC LATITUDE            "; DPSI#; " DEG"
        PRINT " LONGITUDE                      "; DLON#; " DEG"
        PRINT " ALTITUDE                       "; DH#; " M"
        PRINT " GRAVITY                        "; DGRAV#; " M/SEC**2"
        PRINT " GEOCENTRIC RADIUS              "; DR1#; " M"
        PRINT " COMPONENT OF OBSERVATIONS      "; IC%
        PRINT " AZIMUTH FROM NORTH DIRECTION   "; DAZ#; " DEG"
      '
        PRINT #6, " STATION PARAMETERS"
        PRINT #6, " LATITUDE                       "; DLAT#; " DEG"
        PRINT #6, " GEOCENTRIC LATITUDE            "; DPSI#; " DEG"
        PRINT #6, " LONGITUDE                      "; DLON#; " DEG"
        PRINT #6, " ALTITUDE                       "; DH#; " M"
        PRINT #6, " GRAVITY                        "; DGRAV#; " M/SEC**2"
        PRINT #6, " GEOCENTRIC RADIUS              "; DR1#; " M"
        PRINT #6, " COMPONENT OF OBSERVATIONS      "; IC%
        PRINT #6, " AZIMUTH FROM NORTH DIRECTION   "; DAZ#; " DEG"
      END IF
'***********************************************************************
'*    DEFINITION OF ASTRONOMICAL PARAMETERS I.A.U. 1984.               *
'***********************************************************************
      DPAR# = 3422.448#
      DMAS# = 1# / .01230002#
'***********************************************************************
'*    COMPUTATION OF DOODSONS CONSTANT IN METER**2/SEC**2:             *
'***********************************************************************
      DR0# = DEA# * (1# - DEE# / 6# - 5# / 72# * DEE# ^ 2 - 55# / 1296# * DEE# ^ 3)
      DDC# = DR0# ^ 2 * .75# * DEGM# / (DEA# ^ 3 * DMAS#)
      DDC# = DDC# * (DPAR# * DRAD# / 3600#) ^ 3
      DF# = DRO# * .0036# / DGRAV#
      IF IPRINT% > 0 THEN
         PRINT " ASTRONOMIC CONSTANTS INTERNATIONAL ASTRONOMIC UNION"
         PRINT " 1984 M.KG.S-SYSTEM"
         PRINT " MEAN EARTH RADIUS         "; DR0#; " m"
         PRINT " MOONS MEAN SINE PARALLAX  "; DPAR#
         PRINT " MASS RELATION EARTH/MOON  "; DMAS#
         PRINT " DOODSONS CONSTANT         "; DDC#; " m**2/s**2"
         PRINT " F                         "; DF#; " MSECA/(nm/s**2)"
      '
         PRINT #6, " ASTRONOMIC CONSTANTS INTERNATIONAL ASTRONOMIC UNION"
         PRINT #6, " 1984 M.KG.S-SYSTEM"
         PRINT #6, " MEAN EARTH RADIUS         "; DR0#; " m"
         PRINT #6, " MOONS MEAN SINE PARALLAX  "; DPAR#
         PRINT #6, " MASS RELATION EARTH/MOON  "; DMAS#
         PRINT #6, " DOODSONS CONSTANT         "; DDC#; " M**2/SEC**2"
         PRINT #6, " F                         "; DF#; " MSECA/(NM/S**2)"
      END IF
'***********************************************************************
'*    DCPSI IS COS AND DSPSI IS SIN OF GEOCENTRIC LATITUDE.            *
'***********************************************************************
      DCPSI# = COS(DPSI# * DRAD#)
      DSPSI# = SIN(DPSI# * DRAD#)
'***********************************************************************
'*    COMPUTE GEODETIC COEFFICIENTS FOR TIDAL VETCOR ORIENTATED TO     *
'*    SPHERICAL COORDINATE SYSTEM, STORED IN DGXS (NORTH), DGYS(EAST), *
'*    DGZS (RADIALLY UPWARD), DIMENSION IS NM/SEC**2.                  *
'***********************************************************************
      DC2# = DDC# / DR0# * (DR1# / DR0#) * 1000000000#
      DC3# = DDC# / DR0# * (DR1# / DR0#) ^ 2 * 1000000000#
      DC4# = DDC# / DR0# * (DR1# / DR0#) ^ 3 * 1000000000#
      DGXS#(1) = -DC2# * 3# * DSPSI# * DCPSI#
      DGXS#(2) = DC2# * 2# * (DCPSI# ^ 2 - DSPSI# ^ 2)
      DGXS#(3) = -DC2# * 2# * DSPSI# * DCPSI#
      DGXS#(4) = DC3# * 1.118033989# * DCPSI# * (3# - 15# * DSPSI# ^ 2)
      DGXS#(5) = DC3# * .726184378# * DSPSI# * (4# - 15# * DCPSI# ^ 2)
      DGXS#(6) = DC3# * 2.598076212# * DCPSI# * (1# - 3# * DSPSI# ^ 2)
      DGXS#(7) = -DC3# * 3# * DSPSI# * DCPSI# ^ 2
      DGXS#(8) = -DC4# * .125# * DSPSI# * DCPSI# * (60# - 140# * DSPSI# ^ 2)
      DGXS#(9) = DC4# * .473473091# * (6# - 54# * DSPSI# ^ 2 + 56# * DSPSI# ^ 4)
      DGXS#(10) = -DC4# * .777777778# * DCPSI# * (16# * DSPSI# - 28# * DSPSI# ^ 3)
      DGXS#(11) = DC4# * 3.079201436# * DCPSI# ^ 2 * (4# * DCPSI# ^ 2 - 3#)
      DGXS#(12) = -DC4# * 4# * DCPSI# ^ 3 * DSPSI#
      DGYS#(1) = 0#
      DGYS#(2) = 2# * DC2# * DSPSI#
      DGYS#(3) = 2# * DC2# * DCPSI#
      DGYS#(4) = 0#
      DGYS#(5) = DC3 * .726184378# * (1# - 5# * DSPSI# ^ 2)
      DGYS#(6) = 2# * DC3# * 2.598076212# * DSPSI# * DCPSI#
      DGYS#(7) = 3# * DC3# * DCPSI# ^ 2
      DGYS#(8) = 0#
      DGYS#(9) = 2# * DC4# * .473473091# * DSPSI# * (3# - 7# * DSPSI# ^ 2)
      DGYS#(10) = 2# * DC4# * .777777778# * DCPSI# * (1# - 7# * DSPSI# ^ 2)
      DGYS#(11) = 3# * DC4# * 3.079201436# * DSPSI# * DCPSI# ^ 2
      DGYS#(12) = 4# * DC4# * DCPSI# ^ 3
      DGZS#(1) = DC2# * (1# - 3# * DSPSI# ^ 2)
      DGZS#(2) = 4# * DC2# * DSPSI# * DCPSI#
      DGZS#(3) = 2# * DC2# * DCPSI# ^ 2
      DGZS#(4) = 3# * DC3# * 1.118033989# * DSPSI# * (3# - 5# * DSPSI# ^ 2)
      DGZS#(5) = 3# * DC3# * .726184378# * DCPSI# * (1# - 5# * DSPSI# ^ 2)
      DGZS#(6) = 3# * DC3# * 2.598076212# * DSPSI# * DCPSI# ^ 2
      DGZS#(7) = 3# * DC3# * DCPSI# ^ 3
      DGZS#(8) = 4# * DC4# * .125# * (3# - 30# * DSPSI# ^ 2 + 35# * DSPSI# ^ 4)
      DGZS#(9) = 8# * DC4# * .473473091# * DSPSI# * DCPSI# * (3# - 7# * DSPSI# ^ 2)
      DGZS#(10) = 4# * DC4# * .777777778# * DCPSI# ^ 2 * (1# - 7# * DSPSI# ^ 2)
      DGZS#(11) = 4# * DC4# * 3.079201436# * DSPSI# * DCPSI# ^ 3
      DGZS#(12) = 4# * DC4# * DCPSI# ^ 4
'***********************************************************************
'*    COMPUTE GEODETIC COEFFICIENTS FOR TIDAL VECTOR ORIENTATED TO     *
'*    ELLIPSOIDAL COORDINATE SYSTEM STORED IN DGX (NORTH), DGY (EAST)  *
'*    AND DGZ (UPWARD).                                                *
'***********************************************************************
      DCDLAT# = DCLAT# * DCPSI# + DSLAT# * DSPSI#
      DSDLAT# = DSLAT# * DCPSI# - DCLAT# * DSPSI#
      FOR I% = 1 TO 12
      DGX#(I%) = DCDLAT# * DGXS#(I%) - DSDLAT# * DGZS#(I%)
      DGY#(I%) = DGYS#(I%)
      DGZ#(I%) = DSDLAT# * DGXS#(I%) + DCDLAT# * DGZS#(I%)
      NEXT I%
      IC2% = IC% + 2
      IF IC% = -1 THEN GOTO cof100
      IF IC% = 0 THEN GOTO cof200
      IF IC% = 1 THEN GOTO cof300
      IF IC% = 2 THEN GOTO cof400
      IF IC% = 3 THEN GOTO cof500
      IF IC% = 4 THEN GOTO cof600
'***********************************************************************
'*    IC%=-1, COMPUTE GEODETIC COEFFICIENTS FOR TIDAL POTENTIAL.       *
'***********************************************************************
cof100: DC2# = DDC# * (DR1# / DR0#) ^ 2
      DC3# = DDC# * (DR1# / DR0#) ^ 3
      DC4# = DDC# * (DR1# / DR0#) ^ 4
      DGK#(1) = DC2# * .5# * (1# - 3# * DSPSI# ^ 2)
      DGK#(2) = DC2# * 2# * DSPSI# * DCPSI#
      DGK#(3) = DC2# * DCPSI# ^ 2
      DGK#(4) = DC3# * 1.118033989# * DSPSI# * (3# - 5# * DSPSI# ^ 2)
      DGK#(5) = DC3# * .726184378# * DCPSI# * (1# - 5# * DSPSI# ^ 2)
      DGK#(6) = DC3# * 2.598076212# * DSPSI# * DCPSI# ^ 2
      DGK#(7) = DC3# * DCPSI# ^ 3
      DGK#(8) = DC4# * .125# * (3# - 30# * DSPSI# ^ 2 + 35# * DSPSI# ^ 4)
      DGK#(9) = DC4# * .473473091# * 2# * DSPSI# * DCPSI# * (3# - 7# * DSPSI# ^ 2)
      DGK#(10) = DC4# * .777777778# * DCPSI# ^ 2 * (1# - 7# * DSPSI# ^ 2)
      DGK#(11) = DC4# * 3.079201436# * DSPSI# * DCPSI# ^ 3
      DGK#(12) = DC4# * DCPSI# ^ 4
      FOR I% = 1 TO 12
      DPK#(I%) = 0#
      NEXT I%
      GOTO cof1000
'***********************************************************************
'*    IC=0, COMPUTATION OF GEODETIC COEFFICIENTS FOR VERTICAL COMPO-   *
'*          NENT OF TIDAL FORCE (GRAVITY ACCELERATION).                *
'***********************************************************************
cof200: '
      FOR I% = 1 TO 12
      DGK#(I%) = DGZ#(I%)
      DPK#(I%) = 180#
      NEXT I%
      GOTO cof1000
'***********************************************************************
'*    IC=1 OR 2, COMPUTATION OF GEODETIC COEFFICIENTS FOR HORIZONTAL   *
'*               COMPONENT IN AZIMUTH DAZ (TIDAL TILT).                *
'***********************************************************************
cof300: '
      DCAZ# = COS(DAZ# * DRAD#)
      DSAZ# = SIN(DAZ# * DRAD#)
      FOR I% = 1 TO 12
      DGX#(I%) = DGX#(I%) * DF#
      DGY#(I%) = DGY#(I%) * DF#
      DGK#(I%) = SQR((DGX#(I%) * DCAZ#) ^ 2 + (DGY#(I%) * DSAZ#) ^ 2)
      DPK#(I%) = 0#
      IF DGX#(I%) * DCAZ# = 0 THEN
      IF DGY#(I%) * DSAZ = 0 THEN GOTO cof310
      END IF
      CALL ATAN2(DGY#(I%) * DSAZ, DGX#(I%) * DCAZ, DPK#(I%))
      DPK#(I%) = DRO# * DPK#(I%)
cof310: NEXT I%
      GOTO cof1000
'***********************************************************************
'*    IC=3, COMPUTATION OF GEODETIC COEFFICIENTS FOR VOLUMEDILATATION. *
'***********************************************************************
cof400: DC2# = DDC# * (DR1# / DR0#) ^ 2 / (DR1# * DGRAV#) * 1000000000#
      DC3# = DDC# * (DR1# / DR0#) ^ 3 / (DR1# * DGRAV#) * 1000000000#
      DC4# = DDC# * (DR1# / DR0#) ^ 4 / (DR1# * DGRAV#) * 1000000000#
      DGK#(1) = DC2# * .5# * (1# - 3# * DSPSI# ^ 2)
      DGK#(2) = DC2# * 2# * DSPSI# * DCPSI#
      DGK#(3) = DC2# * DCPSI# ^ 2
      DGK#(4) = DC3# * 1.118033989# * DSPSI# * (3# - 5# * DSPSI# ^ 2)
      DGK#(5) = DC3# * .726184378# * DCPSI# * (1# - 5# * DSPSI# ^ 2)
      DGK#(6) = DC3# * 2.598076212# * DSPSI# * DCPSI# ^ 2
      DGK#(7) = DC3# * DCPSI# ^ 3
      DGK#(8) = DC4# * .125# * (3# - 30# * DSPSI# ^ 2 + 35# * DSPSI# ^ 4)
      DGK#(9) = DC4# * .473473091# * 2# * DSPSI# * DCPSI# * (3# - 7# * DSPSI# ^ 2)
      DGK#(10) = DC4# * .777777778# * DCPSI# ^ 2 * (1# - 7# * DSPSI# ^ 2)
      DGK#(11) = DC4# * 3.079201436# * DSPSI# * DCPSI# ^ 3
      DGK#(12) = DC4# * DCPSI# ^ 4
      FOR I% = 1 TO 12
      DPK#(I%) = 0#
      NEXT I%
      GOTO cof1000
'***********************************************************************
'*    IC=4, COMPUTATION OF GEODETIC COEFFICIENTS FOR TIDAL STRAIN.     *
'*          ATTENTION... NOT IMPLEMENTED !!!!!!!!!!                    *
'***********************************************************************
cof500: PRINT " ***** SORRY, COMPONENT IC=4 (TIDAL STRAIN) NOT YET IMPLEMENTED."
      PRINT " ***** ROUTINE ETGCOF STOPS THE EXECUTION. "
      STOP
'***********************************************************************
'*    IC=5, COMPUTATION OF GEODETIC COEFFICIENTS FOR OCEAN TIDES       *
'*    IN MILLIMETER  (THIS IS TIDAL POTENTIAL DIVIDED BY GRAVITY).     *
'***********************************************************************
cof600:  DC2# = DDC# * (DR1# / DR0#) ^ 2 / DGRAV# * 1000#
      DC3# = DDC# * (DR1# / DR0#) ^ 3 / DGRAV# * 1000#
      DC4# = DDC# * (DR1# / DR0#) ^ 4 / DGRAV# * 1000#
      DGK#(1) = DC2# * .5# * (1# - 3# * DSPSI# ^ 2)
      DGK#(2) = DC2# * 2# * DSPSI# * DCPSI#
      DGK#(3) = DC2# * DCPSI# ^ 2
      DGK#(4) = DC3# * 1.118033989# * DSPSI# * (3# - 5# * DSPSI# ^ 2)
      DGK#(5) = DC3# * .726184378# * DCPSI# * (1# - 5# * DSPSI# ^ 2)
      DGK#(6) = DC3# * 2.598076212# * DSPSI# * DCPSI# ^ 2
      DGK#(7) = DC3# * DCPSI# ^ 3
      DGK#(8) = DC4# * .125# * (3# - 30# * DSPSI# ^ 2 + 35# * DSPSI# ^ 4)
      DGK#(9) = DC4# * .473473091# * 2# * DSPSI# * DCPSI# * (3# - 7# * DSPSI# ^ 2)
      DGK#(10) = DC4# * .777777778# * DCPSI# ^ 2 * (1# - 7# * DSPSI# ^ 2)
      DGK#(11) = DC4# * 3.079201436# * DSPSI# * DCPSI# ^ 3
      DGK#(12) = DC4# * DCPSI# ^ 4
      FOR I% = 1 TO 12
      DPK#(I%) = 0#
      NEXT I%
cof1000: ' CONTINUE
      FOR I% = 1 TO 12
      IF DGK#(I%) < 0# THEN
          DGK#(I%) = -DGK#(I%)
          DPK#(I%) = DPK#(I%) + 180#
      END IF
      NEXT I%
'***********************************************************************
'*    PRINT GEODETIC COEFFICIENTS.                                     *
'***********************************************************************
      IF IPRINT% = 0 THEN GOTO cofret
      PRINT " GEODETIC COEFFICIENTS AND PHASES FOR COMPONENT"; IC%
      PRINT " AZIMUTH:"; DAZ#; " DEGREE"
      PRINT " GC 2,0"; DGK#(1); "  "; CUNIT$(IC2%); DPK#(1); " DEGREE"
      PRINT " GC 2,1"; DGK#(2); "  "; CUNIT$(IC2%); DPK#(2); " DEGREE"
      PRINT " GC 2,2"; DGK#(3); "  "; CUNIT$(IC2%); DPK#(3); " DEGREE"
      PRINT " GC 3,0"; DGK#(4); "  "; CUNIT$(IC2%); DPK#(4); " DEGREE"
      PRINT " GC 3,1"; DGK#(5); "  "; CUNIT$(IC2%); DPK#(5); " DEGREE"
      PRINT " GC 3,2"; DGK#(6); "  "; CUNIT$(IC2%); DPK#(6); " DEGREE"
      PRINT " GC 3,3"; DGK#(7); "  "; CUNIT$(IC2%); DPK#(7); " DEGREE"
      PRINT " GC 4,0"; DGK#(8); "  "; CUNIT$(IC2%); DPK#(8); " DEGREE"
      PRINT " GC 4,1"; DGK#(9); "  "; CUNIT$(IC2%); DPK#(9); " DEGREE"
      PRINT " GC 4,2"; DGK#(10); "  "; CUNIT$(IC2%); DPK#(10); " DEGREE"
      PRINT " GC 4,3"; DGK#(11); "  "; CUNIT$(IC2%); DPK#(11); " DEGREE"
      PRINT " GC 4,4"; DGK#(12); "  "; CUNIT$(IC2%); DPK#(12); " DEGREE"
     '
      PRINT #6, " GEODETIC COEFFICIENTS AND PHASES FOR COMPONENT"; IC%
      PRINT #6, " AZIMUTH:"; DAZ#; " DEGREE"
      PRINT #6, " GC 2,0"; DGK#(1); "  "; CUNIT$(IC2%); DPK#(1); " DEGREE"
      PRINT #6, " GC 2,1"; DGK#(2); "  "; CUNIT$(IC2%); DPK#(2); " DEGREE"
      PRINT #6, " GC 2,2"; DGK#(3); "  "; CUNIT$(IC2%); DPK#(3); " DEGREE"
      PRINT #6, " GC 3,0"; DGK#(4); "  "; CUNIT$(IC2%); DPK#(4); " DEGREE"
      PRINT #6, " GC 3,1"; DGK#(5); "  "; CUNIT$(IC2%); DPK#(5); " DEGREE"
      PRINT #6, " GC 3,2"; DGK#(6); "  "; CUNIT$(IC2%); DPK#(6); " DEGREE"
      PRINT #6, " GC 3,3"; DGK#(7); "  "; CUNIT$(IC2%); DPK#(7); " DEGREE"
      PRINT #6, " GC 4,0"; DGK#(8); "  "; CUNIT$(IC2%); DPK#(8); " DEGREE"
      PRINT #6, " GC 4,1"; DGK#(9); "  "; CUNIT$(IC2%); DPK#(9); " DEGREE"
      PRINT #6, " GC 4,2"; DGK#(10); "  "; CUNIT$(IC2%); DPK#(10); " DEGREE"
      PRINT #6, " GC 4,3"; DGK#(11); "  "; CUNIT$(IC2%); DPK#(11); " DEGREE"
      PRINT #6, " GC 4,4"; DGK#(12); "  "; CUNIT$(IC2%); DPK#(12); " DEGREE"
5000 : IF IPRINT > 0 THEN
        PRINT " ***** ROUTINE ETGCOF FINISHED EXECUTION."
        PRINT #6, " ***** ROUTINE ETGCOF FINISHED EXECUTION."
      END IF
      GOTO cofret
'***********************************************************************
'*    FORMAT STATEMENTS.                                               *
'***********************************************************************
cofret: END SUB

      SUB ETGREG (ITY#, ITM#, ITD#, DTH#) STATIC
'***********************************************************************
'*                                                                     *
'*    ROUTINE ETGREG, VERSION 890119 MSQuickBasic 4.0.                 *
'*                                                                     *
'*                                                                     *
'*    THE ROUTINE ETGREG COMPUTES THE GREGORIAN DATE FROM YEAR,        *
'*    MONTH, DAY AND HOUR, WHERE THE HOUR MAY EXCEED 24.               *
'*                                                                     *
'*                                                                     *
'*    INPUT/OUTPUT PARAMETER DESCRIPTION...                            *
'*    =====================================                            *
'*                                                                     *
'*    ALL FOLLOWING PARAMETERS ARE INPUT AND OUTPUT PARAMETERS,        *
'*    WHICH MEANS THAT THE PARAMETERS MAY BE CHANGED DURING            *
'*    EXECUTION OF ROUTINE ETGREG.                                     *
'*                                                                     *
'*    ITY#...      double precision year, e.g. 1971                    *
'*    ITM#...      double precision month, e.g. 1 = January.           *
'*    ITD#...      double precision day.                               *
'*    DTH#...      double precision hour (UTC). The hour may exceed 24.*
'*                                                                     *
'*    Execution time:                                                  *
'*    ----------------                                                 *
'*                                                                     *
'*    The execution time is about 0.000143 s cpu time on 80486 DX2     *
'*    with 66 MHz speed.                                               *
'*                                                                     *
'*    ROUTINE CREATION...    710523 BY H.-G.WENZEL,                    *
'*                           GEODAETISCHES INSTITUT,                   *
'*                           UNIVERSITAET KARLSRUHE,                   *
'*                           ENGLERSTR. 7,                             *
'*                           D-7500 KARLRUHE 1.                        *
'*    ROUTINE MODIFICATION...890119 BY H.-G.WENZEL.                    *
'***********************************************************************
      DIM ID1#(12), ID2#(12)
      ID1#(1) = 31#: ID1#(2) = 28#: ID1#(3) = 31#
      ID1#(4) = 30#: ID1#(5) = 31#: ID1#(6) = 30#
      ID1#(7) = 31#: ID1#(8) = 31#: ID1#(9) = 30#
      ID1#(10) = 31#: ID1#(11) = 30#: ID1#(12) = 31#
      ID2#(1) = 31#: ID2#(2) = 29#: ID2#(3) = 31#
      ID2#(4) = 30#: ID2#(5) = 31#: ID2#(6) = 30#
      ID2#(7) = 31#: ID2#(8) = 31#: ID2#(9) = 30#
      ID2#(10) = 31#: ID2#(11) = 30#: ID2#(12) = 31#
      IH# = INT(DTH# / 24#)
      DTH# = DTH# - 24# * IH#
      ITD# = ITD# + IH#
gre50: L# = INT(ITY# / 4)
      L# = 4# * L#
      IF L# = ITY# THEN GOTO gre300
gre100: IF ITD# <= ID1#(ITM#) THEN GOTO gre555
      ITD# = ITD# - ID1#(ITM#)
      ITM# = ITM# + 1#
      IF ITM# = 13# THEN GOTO gre200
      GOTO gre100
'***********************************************************************
'*    NEXT YEAR.                                                       *
'***********************************************************************
gre200: ITM# = 1#
      ITY# = ITY# + 1#
      GOTO gre50
gre300: IF ITD# <= ID2#(ITM#) THEN GOTO gre555
      ITD# = ITD# - ID2#(ITM#)
      ITM# = ITM# + 1#
      IF ITM# = 13# THEN GOTO gre200
      GOTO gre300
gre555: END SUB

      SUB ETJULD (ITY#, ITM#, ITD#, DTH#, DJULD#) STATIC
'***********************************************************************
'*                                                                     *
'*     ROUTINE ETJULD, VERSION 890119 FORTRAN 77.                      *
'*                                                                     *
'*                                                                     *
'*     THE ROUTINE ETJULD COMPUTES THE JULIAN DATE FROM YEAR,          *
'*     MONTH, DAY, HOURS.                                              *
'*                                                                     *
'*    INPUT PARAMETER DESCRIPTION...                                   *
'*    ==============================                                   *
'*                                                                     *
'*    ITY#...       double precision year, e.g. 1971                   *
'*    ITM#...       double precision month, e.g. 1# = January.         *
'*    ITD#...       double precision day.                              *
'*    DTH#...       hour in UTC.                                       *
'*                                                                     *
'*    OUTPUT PARAMETER DESCRIPTION...                                  *
'*    ===============================                                  *
'*                                                                     *
'*    DJULD#...    double precision Julian date, e.g. for              *
'*                 01. JAN 1988, 0.00 H UTC IS DJULD# = 2447161.500#   *
'*                 01. FEB 1988, 0.00 H UTC IS DJULD# = 2447192.500#   *
'*                 29. FEB 1988, 0.00 H UTC IS DJULD# = 2447220.500#   *
'*                 01. MAR 1988, 0.00 H UTC IS DJULD# = 2447221.500#   *
'*                                                                     *
'*    EXECUTION TIME...                                                *
'*    =================                                                *
'*                                                                     *
'*    ABOUT 0.0054 SEC CPU TIME FOR 1000 CALLS OF ETJULD ON CDC CYBER  *
'*    990 OF RRZN HANNOVER USING OL=HIGH.                              *
'*    ABOUT 1.43 SEC CPU TIME FOR 1000 CALLS OF ETJULD ON IBM-AT WITH  *
'*    8087 COPROCESSOR USING WATFOR87 COMPILER.                        *
'*                                                                     *
'*    NUMERICAL ACCURACY...                                            *
'*    =====================                                            *
'*                                                                     *
'*    THE RESULT ON IBM-AT IS ACCURATE TO 10**-9 DAYS WHICH IS         *
'*    EQUIVALENT TO 0.0001 SEC.                                        *
'*                                                                     *
'*    ROUTINE CREATION...    710523 BY H.-G.WENZEL,                    *
'*                           GEODAETISCHES INSTITUT,                   *
'*                           UNIVERSITAET KARLSRUHE,                   *
'*                           ENGLERSTR. 7,                             *
'*                           D-7500 KARLSRUHE 1,                       *
'*                           FEDERAL REPUBLIC OF GERMANY.              *
'*    ROUTINE MODIFICATION...890119 BY H.-G.WENZEL.                    *
'***********************************************************************
      DIM DTM#(12)
      DTM#(1) = 0#: DTM#(2) = 31#: DTM#(3) = 59#
      DTM#(4) = 90#: DTM#(5) = 120#: DTM#(6) = 151#
      DTM#(7) = 181#: DTM#(8) = 212#: DTM#(9) = 243#
      DTM#(10) = 273#: DTM#(11) = 304#: DTM#(12) = 334#
      DJULD# = 2415019.5#
      ITYR# = ITY# - 1900#
      LEAP# = INT(ITYR# / 4)
      DTA# = ITYR# * 365# + LEAP#
      IF ITM# < 1# THEN GOTO jul5
      IF ITM# > 12# THEN GOTO jul6
      DJULD# = DJULD# + DTA# + DTM#(ITM#) + ITD# + DTH# / 24#
      ITYL# = LEAP# * 4#
      IF ITYR# <> ITYL# THEN GOTO julret
'***********************************************************************
'*    LEAP YEAR.                                                       *
'***********************************************************************
      IF ITM# > 2# THEN GOTO julret
      DJULD# = DJULD# - 1#
      GOTO julret
jul5: PRINT " *****ERROR IN ROUTINE ETJULD, VERSION 890119."
      PRINT " *****MONTH IS LESS 1:"; ITY%; ITM%; ITD%; DTH#
      PRINT " *****ROUTINE ETJULD STOPS EXECUTION."
      PRINT #6, " *****ERROR IN ROUTINE ETJULD, VERSION 890119."
      PRINT #6, " *****MONTH IS LESS 1:"; ITY%; ITM%; ITD%; DTH#
      PRINT #6, " *****ROUTINE ETJULD STOPS THE EXECUTION."
      STOP
jul6: PRINT " *****ERROR IN ROUTINE ETJULD, VERSION 890119."
      PRINT " *****MONTH IS GREATER 12:"; ITY%; ITM%; ITD%; DTH#
      PRINT " *****ROUTINE ETJULD STOPS EXECUTION."
      PRINT #6, " *****ERROR IN ROUTINE ETJULD, VERSION 890119."
      PRINT #6, " *****MOTNH IS GREATER 12:"; ITY%; ITM%; ITD%; DTH#
      PRINT #6, " *****ROUTINE ETJULD STOPS THE EXECUTION."
      STOP
julret: END SUB

      SUB ETMUTC (IPRINT%, DTUJD#, DDT#) STATIC
'***********************************************************************
'*                                                                     *
'*    ROUTINE ETMUTC, VERSION 900301 MS-QuickBasic 4.0.                *
'*                                                                     *
'*                                                                     *
'*    INPUT PARAMETER DESCRIPTION...                                   *
'*    ==============================                                   *
'*                                                                     *
'*    IPRINT%...   PRINTOUT PARAMETER. FOR IPRINT=0, NOTHING WILL BE   *
'*                 PRINTED. FOR IPRINT=2, THE TABLES DTX, DTJULD AND   *
'*                 DTY WILL BE PRINTED FOR THE FIRST CALL OF ROUTINE   *
'*                 ETMUTC.                                             *
'*    DTUJD#...    JULIAN DATE OF EPOCH (UNIVERSAL TIME).              *
'*                                                                     *
'*    OUTPUT PARAMETER DESCRIPTION...                                  *
'*    ===============================                                  *
'*                                                                     *
'*    DDT#...      ET - UTC   RESP. TDT - UTC IN SECONDS FROM 1955.5   *
'*                 TO 1988.0 . FOR EPOCHS LESS 1955.5, DDT=31.59 SEC   *
'*                 WILL BE RETURNED. FOR EPOCHS EXCEEDING 1988.0,      *
'*                 DDT=56.184 SEC WILL BE RETURNED.                    *
'*                 ET  IS EPHEMERIS TIME.                              *
'*                 TDT IS TERRESTRIAL DYNAMICAL TIME.                  *
'*                 UTC IS COORDINATED UNIVERSAL TIME, USED IN RADIO    *
'*                 BROADCAST.                                          *
'*                                                                     *
'*    THE TABLES DTX#, DTJULD#, DTY# HAVE TO BE EXTENDED, WHEN NEW     *
'*    DATA ARE AVAILABLE. CHANGE PARAMETER NTAB% AND DIMENSIONS !!!    *
'*                                                                     *
'*    ROUTINE CREATION...    R.A. BROUCKE,                             *
'*                           JET PROPULSION LABORATORY,                *
'*    ROUTINE MODIFICATION...900301 BY H.-G. WENZEL,                   *
'*                           GEODAETISCHES INSTITUT,                   *
'*                           UNIVERSITAET KARLSRUHE,                   *
'*                           ENGLERSTR. 7,                             *
'*                           D-7500 KARLSRUHE 1.                       *
'***********************************************************************
      DIM DTJULD#(75), DTX#(75), DTY#(75)
'***********************************************************************
'*    TABLE DTX DEFINES THE EPOCH OF DDT DEFINED IN TABLE DTY.         *
'*    DTX IS COUNTED IN YEARS FROM 1900.                               *
'*    TABLE DJULD DEFINES THE EPOCH OF DDT DEFINED IN TABLE DTY.       *
'*    DTJULD IS JULIAN DATE.                                           *
'*    TABLE DTY DEFINES THE DIFFERENCE EPHEMERIS TIME MINUS UTC, OR    *
'*    TERRESTRIAL DYNAMICAL TIME MINUS UTC, AS TAKEN FROM THE          *
'*    ASTRONOMICAL EPHEMERIS.                                          *
'***********************************************************************
      DTX#(1) = 55.5#:     DTJULD#(1) = 2435289.5#:    DTY#(1) = 31.59#
      DTX#(2) = 56.5#:     DTJULD#(2) = 2435655.5#:    DTY#(2) = 32.06#
      DTX#(3) = 57.5#:     DTJULD#(3) = 2436020.5#:    DTY#(3) = 31.82#
      DTX#(4) = 58.5#:     DTJULD#(4) = 2436385.5#:    DTY#(4) = 32.69#
      DTX#(5) = 59.5#:     DTJULD#(5) = 2436750.5#:    DTY#(5) = 33.05#
      DTX#(6) = 60.5#:     DTJULD#(6) = 2437116.5#:    DTY#(6) = 33.16#
      DTX#(7) = 61.5#:     DTJULD#(7) = 2437481.5#:    DTY#(7) = 33.59#
      DTX#(8) = 62#:       DTJULD#(8) = 2437665.5#:    DTY#(8) = 34.032#
      DTX#(9) = 62.5#:     DTJULD#(9) = 2437846.5#:    DTY#(9) = 34.235#
      DTX#(10) = 63#:      DTJULD#(10) = 2438030.5#:   DTY#(10) = 34.441#
      DTX#(11) = 63.5#:    DTJULD#(11) = 2438211.5#:   DTY#(11) = 34.644#
      DTX#(12) = 64#:      DTJULD#(12) = 2438395.5#:   DTY#(12) = 34.95#
      DTX#(13) = 64.5#:    DTJULD#(13) = 2438577.5#:   DTY#(13) = 35.286#
      DTX#(14) = 65#:      DTJULD#(14) = 2438761.5#:   DTY#(14) = 35.725#
      DTX#(15) = 65.5#:    DTJULD#(15) = 2438942.5#:   DTY#(15) = 36.16#
      DTX#(16) = 66#:      DTJULD#(16) = 2439126.5#:   DTY#(16) = 36.498#
      DTX#(17) = 66.5#:    DTJULD#(17) = 2439307.5#:   DTY#(17) = 36.968#
      DTX#(18) = 67#:      DTJULD#(18) = 2439491.5#:   DTY#(18) = 37.444#
      DTX#(19) = 67.5#:    DTJULD#(19) = 2439672.5#:   DTY#(19) = 37.913#
      DTX#(20) = 68#:      DTJULD#(20) = 2439856.5#:   DTY#(20) = 38.39#
      DTX#(21) = 68.25#:   DTJULD#(21) = 2439947.5#:   DTY#(21) = 38.526#
      DTX#(22) = 68.5#:    DTJULD#(22) = 2440038.5#:   DTY#(22) = 38.76#
      DTX#(23) = 68.75#:   DTJULD#(23) = 2440130.5#:   DTY#(23) = 39#
      DTX#(24) = 69#:      DTJULD#(24) = 2440222.5#:   DTY#(24) = 39.238#
      DTX#(25) = 69.25#:   DTJULD#(25) = 2440312.5#:   DTY#(25) = 39.472#
      DTX#(26) = 69.5#:    DTJULD#(26) = 2440403.5#:   DTY#(26) = 39.707#
      DTX#(27) = 69.75#:   DTJULD#(27) = 2440495.5#:   DTY#(27) = 39.946#
      DTX#(28) = 70#:      DTJULD#(28) = 2440587.5#:   DTY#(28) = 40.185#
      DTX#(29) = 70.25#:   DTJULD#(29) = 2440677.5#:   DTY#(29) = 40.42#
      DTX#(30) = 70.5#: DTJULD#(30) = 2440768.5#:      DTY#(30) = 40.654#
      DTX#(31) = 70.75#: DTJULD#(31) = 2440860.5#:     DTY#(31) = 40.892#
      DTX#(32) = 71#: DTJULD#(32) = 2440952.5#: DTY#(32) = 41.131#
      DTX#(33) = 71.08499999999999#: DTJULD#(33) = 2440983.5#: DTY#(33) = 41.211#
      DTX#(34) = 71.16200000000001#: DTJULD#(34) = 2441011.5#: DTY#(34) = 41.284#
      DTX#(35) = 71.247#: DTJULD#(35) = 2441042.5#: DTY#(35) = 41.364#
      DTX#(36) = 71.32899999999999#: DTJULD#(36) = 2441072.5#: DTY#(36) = 41.442#
      DTX#(37) = 71.414#: DTJULD#(37) = 2441103.5#: DTY#(37) = 41.522#
      DTX#(38) = 71.496#: DTJULD#(38) = 2441133.5#: DTY#(38) = 41.6#
      DTX#(39) = 71.581#: DTJULD#(39) = 2441164.5#: DTY#(39) = 41.68#
      DTX#(40) = 71.666#: DTJULD#(40) = 2441195.5#: DTY#(40) = 41.761#
      DTX#(41) = 71.748#: DTJULD#(41) = 2441225.5#: DTY#(41) = 41.838#
      DTX#(42) = 71.833#: DTJULD#(42) = 2441256.5#: DTY#(42) = 41.919#
      DTX#(43) = 71.91500000000001#: DTJULD#(43) = 2441286.5#: DTY#(43) = 41.996#
      DTX#(44) = 71.999#: DTJULD#(44) = 2441317.499#: DTY#(44) = 42.184#
      DTX#(45) = 72#: DTJULD#(45) = 2441317.5#: DTY#(45) = 42.184#
      DTX#(46) = 72.499#: DTJULD#(46) = 2441499.499#: DTY#(46) = 42.184#
      DTX#(47) = 72.5#: DTJULD#(47) = 2441499.5#: DTY#(47) = 43.184#
      DTX#(48) = 72.9999#: DTJULD#(48) = 2441683.499#: DTY#(48) = 43.184#
      DTX#(49) = 73#: DTJULD#(49) = 2441683.5#: DTY#(49) = 44.184#
      DTX#(50) = 73.9999#: DTJULD#(50) = 2442048.499#: DTY#(50) = 44.184#
      DTX#(51) = 74#: DTJULD#(51) = 2442048.5#: DTY#(51) = 45.184#
      DTX#(52) = 74.9999#: DTJULD#(52) = 2442413.499#: DTY#(52) = 45.184#
      DTX#(53) = 75#: DTJULD#(53) = 2442413.5#: DTY#(53) = 46.184#
      DTX#(54) = 75.9999#: DTJULD#(54) = 2442778.499#: DTY#(54) = 46.184#
      DTX#(55) = 76#: DTJULD#(55) = 2442778.5#: DTY#(55) = 47.184#
      DTX#(56) = 76.9999#: DTJULD#(56) = 2443144.499#: DTY#(56) = 47.184#
      DTX#(57) = 77#: DTJULD#(57) = 2443144.5#: DTY#(57) = 48.184#
      DTX#(58) = 77.9999#: DTJULD#(58) = 2443509.499#: DTY#(58) = 48.184#
      DTX#(59) = 78#:      DTJULD#(59) = 2443509.5#:   DTY#(59) = 49.184#
      DTX#(60) = 78.9999#: DTJULD#(60) = 2443874.499#: DTY#(60) = 49.184#
      DTX#(61) = 79#:      DTJULD#(61) = 2443874.5#:   DTY#(61) = 50.184#
      DTX#(62) = 79.9999#: DTJULD#(62) = 2444239.499#: DTY#(62) = 50.184#
      DTX#(63) = 80#:      DTJULD#(63) = 2444239.5#:   DTY#(63) = 51.184#
      DTX#(64) = 81.4999#: DTJULD#(64) = 2444786.499#: DTY#(64) = 51.184#
      DTY#(65) = 81.5#:    DTJULD#(65) = 2444786.5#:   DTY#(65) = 52.184#
      DTX#(66) = 82.4999#: DTJULD#(66) = 2445151.499#: DTY#(66) = 52.184#
      DTX#(67) = 82.5#:    DTJULD#(67) = 2445151.5#:   DTY#(67) = 53.184#
      DTX#(68) = 83.4999#: DTJULD#(68) = 2445516.499#: DTY#(68) = 53.184#
      DTX#(69) = 83.5#:    DTJULD#(69) = 2445516.5#:   DTY#(69) = 54.184#
      DTX#(70) = 85.4999#: DTJULD#(70) = 2446247.499#: DTY#(70) = 54.184#
      DTX#(71) = 85.5#:    DTJULD#(71) = 2446247.5#:   DTY#(71) = 55.184#
      DTX#(72) = 87.9999#: DTJULD#(72) = 2447161.499#: DTY#(72) = 55.184#
      DTX#(73) = 88#:      DTJULD#(73) = 2447161.5#:   DTY#(73) = 56.184#
      DTX#(74) = 89.9999#: DTJULD#(74) = 2447892.499#: DTY#(74) = 56.184#
      DTX#(75) = 90#:      DTJULD#(75) = 2447892.5#:   DTY#(75) = 57.184#
      NTAB% = 75: ITAB% = 1
'***********************************************************************
'*    PRINT TABLE FOR THE FIRST CALL OF ETMUTC.                        *
'***********************************************************************
      IF IPRINT% <> 2 GOTO mut10
      IF ITAB% = 0 GOTO mut10
      PRINT " ROUTINE ETMUTC, VERSION 900301 FORTRAN 77."
      PRINT " LIST OF TABLES:"
      PRINT "                "
      PRINT "       NO.           JULD            DTX       DTY"
      PRINT " "
      PRINT #6, " ROUTINE ETMUTC, VERSION 900301 FORTRAN 77."
      PRINT #6, " LIST OF TABLES:"
      PRINT #6, "                "
      PRINT #6, "       NO.           JULD            DTX       DTY"
      PRINT #6, " "
      FOR I% = 1 TO NTAB%
      PRINT I%, DTX#(I%), DTJULD#(I%), DTY#(I%)
      PRINT #6, I%; DTX#(I%); DTJULD#(I%); DTY#(I%)
      NEXT I%
      ITAB% = 0
mut10: '
      IF DTUJD# < DTJULD#(NTAB%) THEN GOTO mut11
'***********************************************************************
'*    DTUJD EXCEEDS LAST TABULATED EPOCH DTJULD(NTAB).                 *
'***********************************************************************
mut12: DDT# = DTY#(NTAB%)
      IF IWARN% = 0 THEN
        PRINT " ***** WARNING FROM ROUTINE ETMUTC, VERSION 900301."
        PRINT " ***** EPOCH EXCEEDS THE LAST TABULATED VALUE:", DTJULD#(NTAB%)
        PRINT " ***** DDT   USED FOR LAST TABULATED EPOCH."
        PRINT " ***** PLEASE TRY TO UPDATE TABELS IN ROUTINE ETMUC."
        PRINT "  "
        PRINT #6, " ***** WARNING FROM ROUTINE ETMUTC, VERSION 900301."
        PRINT #6, " ***** EPOCH EXCEEDS THE LAST TABULATED VALUE:", DTJULD#(NTAB%)
        PRINT #6, " ***** DDT   USED FOR LAST TABULATED EPOCH."
        PRINT #6, " ***** PLEASE TRY TO UPDATE TABELS IN ROUTINE ETMUC."
        PRINT #6, "  "
      END IF
      IWARN% = 1
      GOTO mutret
mut11: FOR I% = 1 TO NTAB%
      IF DTUJD# < DTJULD#(I%) THEN GOTO mut21
      IF DTUJD# = DTJULD#(I%) THEN GOTO mut22
      IF DTUJD# > DTJULD#(I%) THEN GOTO mut20
mut22: DDT# = DTY#(I%)
       GOTO mutret
mut21: N% = I% - 1
       GOTO mut23
mut20: NEXT I%
mut23: DDT# = (DTY#(N% + 1) * (DTUJD# - DTJULD#(N%)) - DTY#(N%) * (DTUJD# - DTJULD#(N% + 1)))
      DDT# = DDT# / (DTJULD#(N% + 1) - DTJULD#(N%))
      GOTO mutret
mutret: END SUB

      SUB ETPOTW (IPRINT%, IMODEL%, DLAT#, DLON#, DH#, DGRAV#, DAZ#, IC%, ITY#, ITM#, ITD#, DTH#, MAXNW%, DTHAM#(), DTHPH#(), DTHFR#(), NW%)
'***********************************************************************
'*                                                                     *
'*    ROUTINE ETPOTW, VERSION 930528 MS-QuickBasic 4.0.                *
'*                                                                     *
'*    THE ROUTINE ETPOTW COMPUTES AMPLITUDES, PHASES AND FREQUENCIES   *
'*    FOR A CERTAIN TIDAL POTENTIAL DEVELOPMENT.                       *
'*                                                                     *
'*    ATTENTION: THIS ROUTINE VERSION HAS FINALLY BEEN TESTED ONLY     *
'*               FOR VERTICAL AND HORIZONTAL COMPONENTS. !!!           *
'*                                                                     *
'*                                                                     *
'*    INPUT PARAMETER DESCRIPTION...                                   *
'*    ==============================                                   *
'*                                                                     *
'*    IUN4...      FORMATTED UNIT, ON WHICH THE TIDAL POTENTIAL        *
'*                 DEVELOPMENT HAS TO BE STORED BEFORE THE EXECUTION   *
'*                 OF ROUTINE ETPOTW  (E.G. FILE ETCPOT).              *
'*    IPRINT...    PARAMETER FOR PRINTOUT.                             *
'*                 FOR IPRINT = 0, NOTHING WILL BE PRINTED.            *
'*                 FOR IPRINT = 1, A SHORT LIST WILL BE PRINTED.       *
'*                 FOR IPRINT = 2, A LONG  LIST WILL BE PRINTED        *
'*                 (INCLUDING TIDAL POTENTIAL DEVELOPMENT).            *
'*    IMODEL...    PARAMETER FOR SELECTING A CERTAIN TIDAL POTENTIAL   *
'*                 DEVELOPMENT.                                        *
'*                 IMODEL = 0: DOODSON 1921 TIDAL POTENTIAL DEVELOP-   *
'*                             MENT WITH 378 WAVES.                    *
'*                 IMODEL = 1: CARTWRIGHT-TAYLOR-EDDEN 1973 TIDAL      *
'*                             POTENTIAL DEVELOPMENT WITH 505 WAVES.   *
'*                 IMODEL = 2: TAMURA 1987 TIDAL POTENTIAL DEVELOPM-   *
'*                             MENT WITH 1200 WAVES.                   *
'*                 IMODEL = 3: BUELLESFELD 1985 TIDAL POTENTIAL        *
'*                             DEVELOPMENT WITH ??? WAVES.             *
'*    DLAT...      ELLIPSOIDAL LATITUDE IN DEGREE.                     *
'*    DLON...      ELLIPSOIDAL LONGITUDE IN DEGREE, POSITIVE EAST OF   *
'*                 GREENWHICH.                                         *
'*    DH...        ELLIPSOIDAL HEIGHT IN METER.                        *
'*    DGRAV...     GRAVITY IN M/S**2. IF UNKNOWN, PUT DGRAV TO ZERO    *
'*                 (TRUE GRAVITY WILL BE REPLACED BY NORMAL GRAVITY).  *
'*    DAZ...       AZIMUT IN DEGREE FROM NORTH DIRECTION (ONLY VALID   *
'*                 FOR  TIDAL TILT).                                   *
'*    IC...        EARTH TIDE COMPONENT TO BE COMPUTED.                *
'*                 IC=-1... TIDAL POTENTIAL.                           *
'*                 IC= 0... VERTICAL COMPONENT (GRAVITY VARIATION) IN  *
'*                          NM/SEC**2.                                 *
'*                 IC= 1... HORIZONTAL COMPONENT (TIDAL TILT) IN       *
'*                          MILLI ARC SEC IN AZMUTH DAZ.               *
'*                 IC= 2... SAME AS IC = 1.                            *
'*                 IC= 3... VOLUME VARIATION.                          *
'*                 IC= 4... TIDAL STRAIN (NOT IMPLEMENTED).            *
'*                 IC= 5... OCEAN TIDES.                               *
'*    IR...   PRINTING PARAMETER FOR TIDAL POTENTIAL DEVELOPMENT.      *
'*            IR= 0... NO TIDAL POTENTIAL DEVELOPMENT PRINTING.        *
'*            IR= 1... TIDAL POTENTIAL AND TIDAL FORCE DEVELOPMENT     *
'*                     WILL BE PRINTED.                                *
'*    ITY...  YEAR OF START EPOCH OF TIDAL FORCE COMPUTATION.          *
'*    ITM...  MONTH OF START EPOCH OF TIDAL FORCE COMPUTATION.         *
'*    ITD...  DAY   OF START EPOCH OF TIDAL FORCE COMPUTATION.         *
'*    DTH...  HOUR  OF START EPOCH OF TIDAL FORCE COMPUTATION (UT-C).  *
'*            EXAMPLE... 27. OF SEPTEMBER 1984, 10 O'CLOCK UT-2 IS     *
'*            ITY = 1984, ITM = 9, ITD = 27, DTH = 10.D0               *
'*                                                                     *
'*    OUTPUT PARAMETER DESCRIPTION...                                  *
'*    ===============================                                  *
'*                                                                     *
'*    DTHAM...     ARRAY OF TIDAL AMPLITUDES. UNITS ARE MICROGAL AND   *
'*                 MILLI ARC SEC.                                      *
'*    DTHPH...     ARRAY OF TIDAL PHASES IN RADIANS REFERRING TO       *
'*                 INITIAL EPOCH.                                      *
'*    DTHFR...     ARRAY OF TIDAL FREQUENCIES IN RADIANS PER HOUR.     *
'*    NW...        NUMBER OF DEFINED TIDAL WAVES.                      *
'*                                                                     *
'*    USED ROUTINES...                                                 *
'*    ================                                                 *
'*                                                                     *
'*    SUBROUTINE ETASTE : ASTRONOMICAL ELEMENTS.                       *
'*    SUBROUTINE ETGCOF : GEODETIC COEFFICIENTS.                       *
'*    SUBROUTINE ETJULD : JULIAN DATE.                                 *
'*    SUBROUTINE ETMUTC : DIFFERENCE TDT - UTC                         *
'*                                                                     *
'*    NUMERICAL ACCURACY...                                            *
'*    =====================                                            *
'*                                                                     *
'*    THE ROUTINE HAS BEEN TESTED ON CDC CYBER 990 OF RRZN HANNOVER    *
'*    WITH 15 DIGITS IN SINGLE PRECISION AND ON IBM-AT WITH 15         *
'*    DIGITS RESOLUTION IN DOUBLE PRECISION.                           *
'*                                                                     *
'*    EXECUTION TIME...                                                *
'*    =================                                                *
'*                                                                     *
'*    THE CPU EXECUTION TIME DEPENDS MAINLY ON THE NUMBER OF WAVES     *
'*    OF THE TIDAL POTENTIAL DEVELOPMENT. FOR CARTWRIGHT-TAYLOR-EDDEN  *
'*    DEVELOPMENT WITH 505 TIDAL WAVES, THE CPU EXECUTION TIME IS      *
'*    ABOUT 0.37 SEC ON CDC CYBER 990 OF RRZN HANNOVER WITH OL=HIGH.   *
'*                                                                     *
'*    ROUTINE CREATION...    880427 BY H.-G.WENZEL,                    *
'*                           GEODAETISCHES INSTITUT,                   *
'*                           UNIVERSITAET KARLSRUHE,                   *
'*                           ENGLERSTR. 7,                             *
'*                           D-7500 KARLSRUHE 1,                       *
'*                           FEDERAL REPUBLIC OF GERMANY.              *
'*    PROGRAM MODIFICATION...890202 BY H.-G.WENZEL.                    *
'***********************************************************************
      DIM CHEAD$, CENDH$, CUNIT$(7), CWN$
      DIM DX#(3), DY#(3), DHH#(4), NS%(8)
      DIM DAS#(8), DASP#(8), DGK#(12), DPK#(12)
'***********************************************************************
'*    THE FOLLOWING DIMENSION STATEMENT IS CONCERNING THE NUMBER OF    *
'*    WAVES OF THE TIDAL POTENTIAL DEVELOPMENT, WHICH IS MAXNW.        *
'***********************************************************************
REM      DIM DTHAM#(MAXNW), DTHPH#(MAXNW), DTHFR#(MAXNW)
      DIM DGX#(7), DGY#(7)
      CUNIT$(1) = "(M/S)**2"
      CUNIT$(2) = "NM/S**2"
      CUNIT$(3) = " MSECA  "
      CUNIT$(4) = " MSECA  "
      CUNIT$(5) = "10**-9  "
      CUNIT$(6) = "10**-9  "
      CUNIT$(7) = "MM      "
      CENDH$ = "C*********"
      IF IPRINT% = 0 THEN GOTO pot100
      PRINT " ROUTINE ETPOTW, VERSION 920107."
      PRINT " TIDAL FORCE DEVELOPMENT FROM TIDAL POTENTIAL DEVELOPMENT."
      PRINT #6, " ROUTINE ETPOTW, VERSION 920107."
      PRINT #6, " TIDAL FORCE DEVELOPMENT FROM TIDAL POTENTIAL DEVELOPMENT."
      IF IMODEL% = 0 THEN
         PRINT " DOODSON 1921 TIDAL POTENTIAL DEVELOPMENT IS USED."
         PRINT #6, " DOODSON 1921 TIDAL POTENTIAL DEVELOPMENT IS USED."
      END IF
      IF IMODEL% = 1 THEN
         PRINT " CTED 1973 TIDAL POTENTIAL DEVELOPMENT IS USED."
         PRINT #6, " CTED 1973 TIDAL POTENTIAL DEVELOPMENT IS USED."
      END IF
      IF IMODEL% = 2 THEN
         PRINT " TAMURA 1987 TIDAL POTENTIAL DEVELOPMENT IS USED."
         PRINT #6, " TAMURA 1987 TIDAL POTENTIAL DEVELOPMENT IS USED."
      END IF
      IF IMODEL% = 3 THEN
         PRINT " BUELLESFELD 1985 TIDAL POTENTIAL DEVELOPMENT IS USED."
         PRINT #6, " BUELLESFELD 1985 TIDAL POTENTIAL DEVELOPMENT IS USED."
      END IF
pot100: OPEN "ETCPOT.DAT" FOR INPUT AS #4
      DPI# = 4# * ATN(1#)
      DRAD# = DPI# / 180#
      DRO# = 180# / DPI#
'***********************************************************************
'*    COMPUTE GEODETIC COEFFICIENTS.                                   *
'***********************************************************************
      CALL ETGCOF(IPRINT%, DLAT#, DLON#, DH#, DGRAV#, DAZ#, IC%, DGK#(), DPK#())
'***********************************************************************
'*    COMPUTATION OF JULIAN DATE FOR INITIAL EPOCH ITY,ITM,ITD,RTH.    *
'***********************************************************************
      CALL ETJULD(ITY#, ITM#, ITD#, DTH#, DT#)
      DT2000# = (DT# - 2451544#) / 36525#
      DT# = (DT# - 2415020#) / 36525#
'***********************************************************************
'*    COMPUTATION OF ASTRONOMICAL ELEMENTS FOR INITIAL EPOCH.          *
'***********************************************************************
      CALL ETASTE(IPRINT%, IMODEL%, DLON#, ITY#, ITM#, ITD#, DTH#, DAS#(), DASP#())
      IC2% = IC% + 2
'***********************************************************************
'*    INTERPOLATION FACTORS FOR POTENTIAL COEFFICIENTS AT START EPOCH. *
'*    LINEAR LEAST SQUARES INTERPOLATION.                              *
'***********************************************************************
      DX#(1) = .550376# - 1.173312# * DT#
      DX#(2) = .306592# + .144564# * DT#
      DX#(3) = .143033# + 1.028749# * DT#
'***********************************************************************
'*    READ FILE HEADER FROM TIDAL POTENTIAL FILE ON UNIT IUN4.         *
'***********************************************************************
pot800: LINE INPUT #4, CHEAD$
      IF IPRINT% > 0 THEN PRINT CHEAD$
      IF IPRINT% > 0 THEN PRINT #6, CHEAD$
      TEST$ = MID$(CHEAD$, 1, 10)
      IF TEST$ <> CENDH$ THEN GOTO pot800
      INPUT #4, NW% '      READ(IUN4,7005) NW
      IF NW% > MAXNW% THEN GOTO pot5000
'***********************************************************************
'*    NSW COUNTS THE NUMBER OF TIDAL WAVES WITH AMPLITUDES GREATER     *
'*    LIMIT DEPS.                                                      *
'***********************************************************************
      NSW% = 0
      DEPS# = 0#
'***********************************************************************
'*    COMPUTATION OF TIDAL FORCE DEVELOPMENT FROM TIDAL POTENTIAL      *
'*    DEVELOPMENT.                                                     *
'***********************************************************************
      DSH1# = 0#
      DSH2# = 0#
      DSH3# = 0#
      DSHD# = 0#
      DSHT# = 0#
      IW% = 1
pot810: ' CONTINUE
pot815: ' CONTINUE
'***********************************************************************
'*    NRT IS THE WAVE NUMBER OF TAMURA 1987 TIDAL POTENTIAL            *
'*    DEVELOPMENT, NRC IS THE WAVE NUMBER OF CARTWRIGHT-TAYLER-EDDEN   *
'*    1973 TIDAL POTENTIAL DEVELOPMENT.                                *
'***********************************************************************
'      READ(IUN4,7006,END=900) NRT,NRC,K,(NS(J),J=1,8),NP,
'     1 (DHH(J),J=1,3),CWN,DHD,DHT,DHTD,DHB
      LINE INPUT #4, CHEAD$
      IF (EOF(4)) THEN GOTO pot900
      NRT% = VAL(MID$(CHEAD$, 1, 4))
      NRC% = VAL(MID$(CHEAD$, 5, 4))
      K% = VAL(MID$(CHEAD$, 9, 2))
      NS%(1) = VAL(MID$(CHEAD$, 11, 2))
      NS%(2) = VAL(MID$(CHEAD$, 13, 2))
      NS%(3) = VAL(MID$(CHEAD$, 15, 2))
      NS%(4) = VAL(MID$(CHEAD$, 17, 2))
      NS%(5) = VAL(MID$(CHEAD$, 19, 2))
      NS%(6) = VAL(MID$(CHEAD$, 21, 2))
      NS%(7) = VAL(MID$(CHEAD$, 23, 2))
      NS%(8) = VAL(MID$(CHEAD$, 25, 2))
      NP% = VAL(MID$(CHEAD$, 27, 2))
      DHH#(1) = VAL(MID$(CHEAD$, 29, 7))
      DHH#(2) = VAL(MID$(CHEAD$, 36, 7))
      DHH#(3) = VAL(MID$(CHEAD$, 43, 7))
      CWN$ = MID$(CHEAD$, 50, 5)
      DHD# = VAL(MID$(CHEAD$, 55, 7))
      DHT# = VAL(MID$(CHEAD$, 62, 8))
      DHTD# = VAL(MID$(CHEAD$, 70, 9))
      DHB# = VAL(MID$(CHEAD$, 79, 8))
'      PRINT CHEAD$
'      PRINT NRT%; NRC%; DHH#(1); DHH#(2); DHH#(3); CWN$; DHD#; DHTD#; DHTD#; DHB#
      DSHT# = DSHT# + DHT#
'**********************************************************************
'*    THE NEXT IF IS FOR THE WAVES CONTAINING IN TAMURAS DEVELOPMENT  *
'*    BUT NOT IN CTED DEVELOPMENT.                                    *
'**********************************************************************
      IF NRC% = 0 THEN
       IF IMODEL% < 2 THEN GOTO pot815
      END IF
'**********************************************************************
'*    THE NEXT IF IS FOR THE WAVES CONTAINING IN CTED DEVELOPMENT     *
'*    BUT NOT IN TAMURAS DEVELOPMENT.                                 *
'**********************************************************************
      IF NRT% = 0 THEN
        IF IMODEL% = 2 THEN GOTO pot815
      END IF
      J% = IW% - 1
'     IF(MOD(J,51).EQ.0.AND.IPRINT.EQ.2) WRITE(IUN6,7007) ITY,ITM,ITD,
'    1 DTH,IC,NW,CUNIT(IC2)
      DHH#(4) = 0#
      DSH1# = DSH1# + DHH#(1)
      DSH2# = DSH2# + DHH#(2)
      DSH3# = DSH3# + DHH#(3)
      DSHD# = DSHD# + DHD#
      FOR J% = 1 TO 3
      DHH#(4) = DHH#(4) + DHH#(J%) * DX#(J%)
      NEXT J%
      IF IMODEL% = 0 THEN DHH#(4) = DHD#
      IF IMODEL% = 3 THEN DHH#(4) = DHB#
'***********************************************************************
'*    TAMURA 1987 TIDAL POTENTIAL DEVELOPMENT WILL BE USED:            *
'***********************************************************************
      IF IMODEL% = 2 THEN DHH#(4) = DHT# + DHTD# * DT2000#
      IF DHH#(4) >= DEPS# THEN NSW% = NSW% + 1
      DC2# = 0#
      DC3# = 0#
      FOR J% = 1 TO 8
      DC2# = DC2# + NS%(J%) * DAS#(J%)
      DC3# = DC3# + NS%(J%) * DASP#(J%)
      NEXT J%
      J% = (K% + 1) * K% / 2 - 2 + NS%(1)
      DC2# = DC2# + DPK#(J%) + NP% * 90#
      DC1# = DHH#(4) * DGK#(J%)
      IF DC1# >= 0# THEN GOTO pot850
      DC1# = -DC1#
      DC2# = DC2# - 180#
pot850: IF DC2# > 360# THEN DC2# = DC2# - 360#
      IF DC2# > 0# THEN GOTO pot860
      DC2# = DC2# + 360#
      GOTO pot850
pot860: ' CONTINUE
      DTHAM#(IW%) = DC1#
      DTHPH#(IW%) = DC2# * DRAD#
      DTHFR#(IW%) = DC3# * DRAD#
      IF IPRINT% <> 2 THEN GOTO pot870
      PRINT #6, IW%; NRT%; DTHAM#(IW%); DC2#; DC3#
      IF DHH#(4) < DEPS# THEN GOTO pot870
      DDD# = (DHT# - DHH#(4)) * 1000000#
'      WRITE(IUN6,7008) NRT,NRC,K,(NS(J),J=1,8),NP,DHH(4),DC1,DC2,DC3,
'     1 CWN,DDD
'      WRITE(IUN7,7008) NRT,NRC,K,(NS(J),J=1,8),NP,DHH(4),DC1,DC2,DC3,
'     1 CWN,DDD
pot870: IW% = IW% + 1
      GOTO pot810
pot900: ' CONTINUE
      NW% = IW% - 1
      IF IPRINT% = 0 THEN GOTO potret
       PRINT #6, "controls "; DSH1#; " "; DSH2#; " "; DSH3#; " "; DSHD#; " "; DSHT#
'      WRITE(IUN7,7009) DSH1,DSH2,DSH3,DSHD,DSHT
       PRINT #6, " Number of waves: "; NW%
       PRINT #6, " Threshold      : "; DEPS#
       PRINT #6, " Number of waves exceeding threshold: "; NSW%
'      WRITE(IUN7,7010) NW,DEPS,NSW
'      WRITE(IUN6,7030)
'      WRITE(IUN7,7030)
      GOTO potret
pot5000: ' CONTINUE
      CLOSE #4
      STOP
'CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
'     FORMAT STATEMENTS.                                               C
'CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
'7005 FORMAT(2I5)
'7006 FORMAT(2I4,10I2,3F7.5,1X,A4,F7.5,F8.6,F9.6,F8.6)
'7007 FORMAT('1ROUTINE ETPOTW, VERSION 920107 FORTRAN 77'//
'    1' TIDAL POTENTIAL AND TIDAL FORCE DEVELOPMENT'/' INITIAL EPOCH',
'    2 I6,2(1H.,I2),F5.2/' COMPONENT: ',I4/' NUMBER OF WAVES: ',I4//
'    3' NR. ARGUM.  ARGUM.NRS. NP  H1870  H1924',
'    4'  H1960   H(T)   AMPL.  PHASE   FREQUENCY'/
'    5 56X,A6,' [DEG]  [DEG/HOUR]'/)
'7008 FORMAT(1X,2I4,10I2,F7.5,F8.4,F9.4,F12.8,1X,A4,F8.0)
'7009 FORMAT(//' CONTROLS FOR TIDAL POTENTIAL :'/5F10.6)
'7010 FORMAT(//' NUMBER OF WAVES IS                   :',I6/
'    1' NUMBER OF WAVES EXCEEDING',F10.6,' IS:',I6/)
'7012 FORMAT(3F10.5,2X,A6)
'7028 FORMAT(8A10)
'7029 FORMAT(8A10)
'7030 FORMAT(///' ***** ROUTINE ETPOTW FINISHED EXECUTION.'/)
'7050 FORMAT(/' ***** ERROR IN ROUTINE ETPOTW, VERSION 890202.'/
'    1' ***** THE CURRENT NUMBER OF WAVES:',I5,' EXCEEDS THE MAXIMUM',
'    2' NUMBER OF WAVES:',I5/
'    3' ***** ROUTINE ETPOTW STOPS THE EXECUTION.'/)
potret: END SUB

      SUB GEOEXT (DEXTIM#) STATIC
'***********************************************************************
'*                                                                     *
'*    Routine GEOEXT, version 930418 MS-QuickBasic 4.0.                *
'*                                                                     *
'*                                                                     *
'*    The routine GEOEXT computes the actual job time and writes       *
'*    the actual execution time on printer output unit IUN6.           *
'*    For the first call of routine GEOEXT, the actual jobtime will    *
'*    be computed (in secs since midnight) and stored. For the next    *
'*    call(s) of routine GEOEXT, the actual jobtime will be computed   *
'*    and the execution time (actual jobtime minus jobtime of the      *
'*    first call of routine GEOEXT) will be printed.                   *
'*                                                                     *
'*    Input parameter description:                                     *
'*    ----------------------------                                     *
'*                                                                     *
'*    IUN6...      formatted printer unit.                             *
'*                                                                     *
'*    Output parameter description:                                    *
'*    -----------------------------                                    *
'*                                                                     *
'*    DEXTIM...    actual jobtime in seconds (time elapsed from the    *
'*                 first call of routine GEOEXT to the actual call of  *
'*                 routine GEOEXT.), double precision.                 *
'*                                                                     *
'*    used routines:                                                   *
'*    --------------                                                   *
'*                                                                     *
'*    Subroutine GETTIM for WATFOR87 or IBM PROFESSIONAL FORTRAN       *
'*    compiler.                                                        *
'*                                                                     *
'*    Program creation:  790830 by H.-G. Wenzel,                       *
'*                       Geodaetisches Institut,                       *
'*                       Universitaet Karlsruhe,                       *
'*                       Englerstr. 7,                                 *
'*                       D-7500 KARLSRUHE 1,                           *
'*                       Germany.                                      *
'*                       Tel.: 0721-6082301.                           *
'*                       FAX:  0721-694552.                            *
'*                       e-mail: wenzel@gik.bau-verm.uni-karlsruhe.de  *
'*    Last Modification: 930418 by H.-G.Wenzel.                        *
'***********************************************************************
      IF IZ1% <> IZ2% THEN GOTO ext6003
ext6001: IZ1% = 10000
      DTIME1# = TIMER
      PRINT " First call of routine GEOEXT, version 930418."
      PRINT #6, " First call of routine GEOEXT, version 930418."
      DEXTIM# = 0#
      GOTO extret
ext6003: DTIME2# = TIMER
      DEXTIM# = DTIME2# - DTIME1#
      PRINT " Routine GEOEXT. Execution time="; DEXTIM#; " sec"
      PRINT #6, " Routine GEOEXT. Execution time="; DEXTIM#; " sec"
extret: END SUB

      SUB TIDE5 (IPRINT%, ITY#, ITM#, ITD#, HR#, MN#, SC#, GT#) STATIC
'***********************************************************************
'*                                                                     *
'*    Routine TIDE5, Version 930606 MS-QuickBasic 4.0.                 *
'*                                                                     *
'*    The routine computes the gravity tide due to the Sun and the     *
'*    Moon from DOODSON 1921, CTED 1973, BUELLESFELD 1985 or TAMURA    *
'*    1987 tidal potential development.                                *
'*                                                                     *
'*    Input parameters:                                                *
'*    -----------------                                                *
'*                                                                     *
'*    IPRINT% : print parameter. IPRINT% = 0: nothing will be printed. *
'*                               IPRINT% = 1: short printout.          *
'*                               IPRINT% = 2: long printout.           *
'*    ITY#    : year since 1900 (e.g. YR# = 93 for year 1993).         *
'*    ITM#    : month (January =1, December =12).                      *
'*    ITD#    : day.                                                   *
'*    HR#     : hour in UTC.                                           *
'*    MN#     : minute in UTC.                                         *
'*    SC#     : second in UTC.                                         *
'*                                                                     *
'*    Output parameter description:                                    *
'*    -----------------------------                                    *
'*                                                                     *
'*    GT#     : gravity tide in nm/s**2 at station LATP#, LONP#,       *
'*              date YR#,MO#,DY#, and time HR#,MN#,SC#.                *
'*              In order to regard the elasticity of the Earth, an     *
'*              amplitude factor of 1.17 is used for the computation   *
'*              of GT#.                                                *
'*                                                                     *
'*    Execution time is 0.05 sec on IBM Ps/2 model 30 (80286/287) with *
'*    10 Mhz speed.                                                    *
'*                                                                     *
'*    Original program source code is from program ETGTAB.FOR, written *
'*    by H.-G. Wenzel. Routine TIDE5 has been translated to            *
'*    MS-QuickBasic at 930606 by H.-G. Wenzel,                         *
'*                               Geodaetisches Institut,               *
'*                               Universitaet Karlsruhe,               *
'*                               Englerstr. 7,                         *
'*                               D-7500 KARLSRUHE 1.                   *
'***********************************************************************
      DIM DTHAM#(1200), DTHPH#(1200), DTHFR#(1200)
      DIM NA%(50), NE%(50), DG0#(50), DPHI0#(50)
      MAXNW% = 1200
      IMODEL% = 2
      IC% = 0
      IF INIT% > 0 THEN GOTO noinit
'***********************************************************************
'*    Initialization of arrays:                                        *
'***********************************************************************
      INIT% = 1
      OPEN "ETGTAB.INP" FOR INPUT AS #2
'***********************************************************************
'*    Read station parameters from file RECTID.INP:                    *
'***********************************************************************
      LINE INPUT #2, CIN$
      DLAT# = VAL(MID$(CIN$, 31, 10))
      LINE INPUT #2, CIN$
      DLON# = VAL(MID$(CIN$, 31, 10))
      LINE INPUT #2, CIN$
      DH# = VAL(MID$(CIN$, 31, 10))
'***********************************************************************
'*    Read earth tide parameter from file RECTID.INP:                  *
'***********************************************************************
      LINE INPUT #2, CIN$
      NGR% = VAL(MID$(CIN$, 31, 10))
      FOR IG% = 1 TO NGR%
      LINE INPUT #2, CIN$
      NA%(IG%) = VAL(MID$(CIN$, 41, 5))
      NE%(IG%) = VAL(MID$(CIN$, 46, 5))
      DG0#(IG%) = VAL(MID$(CIN$, 51, 10))
      DPHI0#(IG%) = VAL(MID$(CIN$, 61, 10))
      PRINT #6, " wave groups: "; NA%(IG%); NE%(IG%); DG0#(IG%); DPHI0#(IG%)
      NEXT IG%
      PI# = 3.141592653589793#
      RAD# = PI# / 180#
      CLOSE #2
'***********************************************************************
'*    Read tidal potential development:                                *
'***********************************************************************
      CALL ETPOTW(IPRINT%, IMODEL%, DLAT#, DLON#, DH#, DGRAV#, DAZ#, IC%, ITY#, ITM#, ITD#, DTH#, MAXNW%, DTHAM#(), DTHPH#(), DTHFR#(), NW%)
      DTH# = HR# + MN# / 60# + SC# / 3600#
      CALL ETJULD(ITY#, ITM#, ITD#, DTH#, DT0#)
'***********************************************************************
'*    Modify tidal waves for earth tide parameters:                    *
'***********************************************************************
      FOR IG% = 1 TO NGR%
      FOR IW% = NA%(IG%) TO NE%(IG%)
      DTHAM#(IW%) = DTHAM#(IW%) * DG0#(IG%)
      DTHPH#(IW%) = DTHPH#(IW%) + DPHI0#(IG%) * RAD#
'      PRINT " *******"; IW%; DTHAM#(IW%); DTHPH#(IW%)
      NEXT IW%
      NEXT IG%
      DDT# = 0#
noinit: '
'***********************************************************************
'*    Compute tides:                                                   *
'***********************************************************************
      DTH# = HR# + MN# / 60# + SC# / 3600#
      CALL ETJULD(ITY#, ITM#, ITD#, DTH#, DT#)
'      DDT# = (DT# - DT0#) * 24#
      GT# = 0#
      FOR IG% = 1 TO NGR%
      FOR IW% = NA%(IG%) TO NE%(IG%)
      GT# = GT# + DTHAM#(IW%) * COS(DTHPH#(IW%) + DDT# * DTHFR#(IW%))
      NEXT IW%
      NEXT IG%
      DDT# = DDT# + 1#
      END SUB

